#pragma once
#include "../../Utils/Logger.h"

class DefaultConfig
{
public:
  DefaultConfig()
    : m_displayMap(false)
    , m_displayEnemyInfluenceMap(false)
    , m_displaySelfInfluenceMap(false)
    , m_displayVisibilityInfluenceMap(false)
    , m_displayStructureInfluenceMap(false)
    , m_displayOwnUnitsActions(true)
  {}

  static unsigned int getDefaultLoggerEvents()
  {
    return LogTypes::ALL & ~LogTypes::ON_FRAME;
  }
  int getLocalSpeedForSinglePlayerGames() const
  {
    return 0;
  }
  bool displayMap() const { return m_displayMap;}
  void setDisplayMap(bool displayMap) { m_displayMap = displayMap; }
  bool displayEnemyInfluenceMap() const { return m_displayEnemyInfluenceMap; }
  void setDisplayEnemyInfluenceMap(bool displayEnemyInfluenceMap) { m_displayEnemyInfluenceMap = displayEnemyInfluenceMap; }
  bool displaySelfInfluenceMap() const { return m_displaySelfInfluenceMap; }
  void setDisplaySelfInfluenceMap(bool displaySelfInfluenceMap) { m_displaySelfInfluenceMap = displaySelfInfluenceMap; }
  bool displayVisibilityInfluenceMap() const { return m_displayVisibilityInfluenceMap; }
  void setDisplayVisibilityInfluenceMap(bool displayVisibilityInfluenceMap) { m_displayVisibilityInfluenceMap = displayVisibilityInfluenceMap; }
  bool displayStructureInfluenceMap() const { return m_displayStructureInfluenceMap; }
  void setDisplayStructureInfluenceMap(bool displayStructureInfluenceMap) { m_displayStructureInfluenceMap = displayStructureInfluenceMap; }
  bool displayOwnUnitsActions() const { return m_displayOwnUnitsActions; }
  void setDisplayOwnUnitsActions(bool displayOwnUnitsActions) { m_displayOwnUnitsActions = displayOwnUnitsActions; }

private:
  bool m_displayMap;
  bool m_displayEnemyInfluenceMap;
  bool m_displaySelfInfluenceMap;
  bool m_displayVisibilityInfluenceMap;
  bool m_displayStructureInfluenceMap;
  bool m_displayOwnUnitsActions;
};

typedef DefaultConfig Config;