#pragma once
#include "../LowLevelAction.h"

namespace layer1
{
  class BuildAction : public LowLevelAction
  {
  public:
    BuildAction(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Build ";
    }
    void setDestination(BWAPI::TilePosition destination)
    {
      if(!destination.isValid())
        m_destination = destination.makeValid();
	  else
        m_destination = destination;
    }
    void setUnitType(BWAPI::UnitType unitType)
    {
      m_unitType = unitType;
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
      return unit->build(m_destination,m_unitType);
    }
  protected:
    BWAPI::TilePosition m_destination;
    BWAPI::UnitType m_unitType;
  };
}