#pragma once
#include "../LowLevelAction.h"

namespace layer1
{
  class MoveAction : public LowLevelAction
  {
  public:
    MoveAction(IBehaviorState& state)
      : LowLevelAction(state)
    {
    }
    virtual std::string getDescription() const
    {
      return "Move " + getObjectDescription(m_destination);
    }
    void setDestination(BWAPI::Position destination)
    {
      if(!destination.isValid())
      {
        assert(destination.isValid());
        m_destination = destination.makeValid();
      }
	    else
        m_destination = destination;
    }
    BWAPI::Position getDestination()
    {
      return m_destination;
    }
    virtual bool execute(BWAPI::Unit* unit) const
    {
      return unit->move(m_destination);
    }
  protected:
    BWAPI::Position m_destination;
  };
}