#pragma once
#include "../../GroupBehavior.h"
#include "../../BehaviorState.h"
#include "../../Arbitrator.h"

/**
 * @brief EngageEnemies is the base class for behaviors commanding a group to engage enemies.
 *        This behavior can terminate with the "Retreat" mode.
 */
class IEngageEnemies : public virtual IGroupBehavior
{
public:
  IEngageEnemies(const Process* parent, unsigned int initialPriority, const PersistentUnitGroup* group)
    : IGroupBehavior(parent, initialPriority, group)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
  {
  }

  // Additional possible termination mode
  static const TerminationMode Retreat;
};

template <class DerivedBehavior>
class EngageEnemies : public virtual IEngageEnemies, public GroupBehavior<DerivedBehavior>
{
public:
  EngageEnemies(const Process* parent, unsigned int initialPriority, const PersistentUnitGroup* group)
    : IEngageEnemies(parent, initialPriority, group)
    , GroupBehavior(parent, initialPriority, group)
    , IGroupBehavior(parent, initialPriority, group)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
  {
  }
};