#pragma once
#include "../../UnitBehavior.h"
#include "../../BehaviorState.h"
#include "../../Layer1FSM.h"
#include "../../Actions/AttackUnitAction.h"
#include "../../Conditions/CompositeCondition.h"
#include "../../Conditions/HasCriticalHealth.h"
#include "../../Conditions/HasRangedAttack.h"
#include "../../Conditions/IsTargeted.h"
#include "../../Conditions/IsWorthFleeing.h"
#include "../../../../../UnitManager.h"
#include "../../../../../../Utils/ReferenceCounted.h"
#include "UnitAttackFSM.h"
#include <BWAPI.h>

//TODO: Needs to be cleaned!!!

class HighTemplarAttack : public UnitAttackFSM<HighTemplarAttack>
{
  class Engaging;
  class Fleeing;
  class Idling;

public:
  HighTemplarAttack(const Process* parent, unsigned int initialPriority, BWAPI::Unit* unit)
    : UnitAttackFSM(parent, initialPriority, unit)
    , IUnitAttackFSM(parent, initialPriority, unit)
    , IUnitBehavior(parent, initialPriority, unit)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
    , m_engagingState(*this)
    , m_fleeingState(*this)
    , m_idlingState(*this)
    , m_states(m_engagingState, m_fleeingState, m_idlingState)
  {
    m_target == NULL;
  }

  virtual std::string getName() const
  {
    return "HighTemplarAttack (" + getObjectDescription(m_unit) + ")";
  }

  bool selectTarget(const UnitGroup& enemies);

protected:
  virtual void executeImpl()
  {
    UnitBehavior::executeImpl();
    m_idlingState.onEnter();
  }

private:
  BWAPI::Unit* selectTargetImpl(UnitGroup enemies);

  BWAPI::Position* m_target;

  // Engaging state ////////////////////////////////////////////////////////////
  class Engaging : public BehaviorState<HighTemplarAttack, Engaging>
  {
  public:
    Engaging(HighTemplarAttack& behavior);
    void onEnterImpl();
    void onExitImpl();

    void onTimer();

    //void targetChanged(BWAPI::Unit* oldTarget);
  private:

    //layer1::AttackUnitAction m_attackAction;

    typedef Transition<Engaging, NoCondition, NoTransitionAction, Idling> SpellCastedTransition;
    TargetDefeatedTransition m_spellCastedTransition;

    //typedef Transition<Engaging, CompositeCondition<HasCriticalHealth,IsWorthFleeing>, NoTransitionAction, Fleeing> LowHealthTransition;
    //LowHealthTransition m_lowHealth;

    typedef SCHEDULER_EVENT(Engaging, onTimer) TimerEvent;
    TimerEvent m_timerEvent;

  public:
    typedef boost::tuple<
      TimerEvent&
    > Events;
    const Events m_events;

    typedef boost::tuple<
      SpellCastedTransition&
    > Transitions;
    const Transitions m_transitions;
  };