#include "stdafx.h"
#include "UnitAttackFSM.h"
#include "DragoonAttack.h"
#include "DefaultAttack.h"
#include <BWAPI.h>
//#include <cassert>
IUnitAttackFSM* IUnitAttackFSM::NewAttackFSM(const Process* parent, unsigned int initialPriority, BWAPI::Unit* unit)
{
  if(unit->getType() == BWAPI::UnitTypes::Protoss_Dragoon)
    return new DragoonAttackFSM(parent, initialPriority, unit);
  else
    return new DefaultAttackFSM(parent, initialPriority, unit);
  
}

//// Engaging state //////////////////////////////////////////////////////////////
//UnitAttackFSM::Engaging::Engaging(UnitAttackFSM& behavior)
//  : BehaviorState(behavior)
//  , m_attackAction(*this)
//  , m_targetDefeated(*this, NoCondition(), NoTransitionAction(), behavior.m_idlingState)
//  , m_lowHealth(
//      *this,
//      CompositeCondition<HasCriticalHealth,IsWorthFleeing>(
//        HasCriticalHealth(behavior.m_unit),
//        IsWorthFleeing(behavior.m_unit)),
//      NoTransitionAction(),
//      behavior.m_fleeingState)
//  , m_timerEvent(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 5, 5)
//  , m_events(m_timerEvent)
//  , m_transitions(m_targetDefeated, m_lowHealth)
//{
//}
//
//void UnitAttackFSM::Engaging::onEnterImpl()
//{
//  assert(m_context.m_target != NULL);
//
//  //selectTarget();
// /* if(m_context.m_target!= NULL)
//  {*/
//    m_targetDefeatedId = Spar->getUnitManager().subscribeIndividualUnitDestroy(m_context.m_target, &m_targetDefeated, NULL);
//
//    m_attackAction.setUnitToAttack(m_context.m_target);
//    
//    Layer1FSM::getInstance().getArbitrator().
//      submitAction(m_context.m_unit, m_attackAction, Arbitration::ActionImportance(*this));
//  //}
//}
//
//void UnitAttackFSM::Engaging::onExitImpl()
//{
//  if(m_context.m_target!= NULL)
//    Spar->getUnitManager().unsubscribeIndividualUnitDestroy(m_context.m_target, m_targetDefeatedId);
//}
//
//void UnitAttackFSM::Engaging::onTimer()
//{
// // if(m_context.m_target= NULL)
//  //  m_targetDefeated.testTransition(boost::make_tuple());
//  m_lowHealth.testTransition(boost::make_tuple());
//}
//
//void UnitAttackFSM::Engaging::targetChanged(BWAPI::Unit* oldTarget)
//{
//    Spar->getUnitManager().unsubscribeIndividualUnitDestroy(oldTarget, m_targetDefeatedId);
//    if(m_context.m_target != NULL)
//      m_targetDefeatedId = Spar->getUnitManager().subscribeIndividualUnitDestroy(m_context.m_target, &m_targetDefeated, NULL);
//}
//
//// Fleeing state ///////////////////////////////////////////////////////////////
//UnitAttackFSM::Fleeing::Fleeing(UnitAttackFSM& behavior)
//  : BehaviorState(behavior)
//  , m_moveAction(*this)
//  , m_transition(*this, Not<IsTargeted>(IsTargeted(behavior.m_unit)), NoTransitionAction(), behavior.m_idlingState)
//  , m_timerEvent(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 5, 5)
//  , m_events(m_timerEvent)
//  , m_transitions(m_transition)
//{
//}
//
//void UnitAttackFSM::Fleeing::onEnterImpl()
//{
//  BWAPI::Position position = Spar->getPerceptualState().getSafeRetreatPosition(m_context.m_unit);
//  m_moveAction.setDestination(position);
//
//  Layer1FSM::getInstance().getArbitrator().
//    submitAction(m_context.m_unit, m_moveAction, Arbitration::ActionImportance(*this));
//}
//
//void UnitAttackFSM::Fleeing::onExitImpl()
//{
//}
//
//void UnitAttackFSM::Fleeing::onTimer()
//{
//  m_transition.testTransition(boost::make_tuple());
//}
//
//// Idling state ////////////////////////////////////////////////////////////////
//UnitAttackFSM::Idling::Idling(UnitAttackFSM& behavior)
//  : BehaviorState(behavior)
//  , m_transition(*this, NoCondition(), NoTransitionAction(), behavior.m_engagingState)
//  , m_transitions(m_transition)
//{
//}
//
//void UnitAttackFSM::Idling::onTargetChanged()
//{
//  // Transition to Engaging state
//  m_transition.testTransition(boost::make_tuple());
//}
//
////TODO: really should be split in two FSM.  one for zealot, one for dragoons
//bool UnitAttackFSM::selectTarget(const UnitGroup& enemies)
//{
//    //UnitGroup enemies = Spar->getPerceptualState().getEnemiesNearUnit(m_context.m_unit, 500); //random value for the range
//  BWAPI::Unit* oldTarget = m_target;
//    if(m_unit->getType() == BWAPI::UnitTypes::Protoss_Zealot)
//      m_target = selectZealotTarget(enemies);
//    else 
//      m_target = selectDragoonTarget(enemies);
//    if(m_currentState == &m_engagingState)
//      m_engagingState.targetChanged(oldTarget);
//    if(m_target == NULL)
//      return false;
//    if (m_currentState == &m_idlingState)
//      m_idlingState.onTargetChanged();
//
//    return true;
//}
//
//BWAPI::Unit* UnitAttackFSM::selectZealotTarget(UnitGroup enemies)
//{
//    //int minhp = boost::numeric::bounds<int>::highest();
//    int mindist = boost::numeric::bounds<int>::highest();
//    bool threatFound = false;
//    BWAPI::Unit* target = NULL;
//
//    for(UnitGroup::const_iterator i=enemies.begin(); i!=enemies.end(); ++i)
//    {
//      BWAPI::Unit* unit = *i;
//      if(!unit->isVisible(BWAPI::Broodwar->self()))
//        continue;
//
//      int dist = unit->getDistance(m_unit->getPosition());
//      //not a threat if the unit is a worker or if the unit is a building that cannot attack
//      bool isThreat = !(unit->getType().isWorker() || (unit->getType().isBuilding() && !unit->getType().canAttack()));
//
//      if(dist < mindist) //TODO: make more precise.  e.g., Attack units before buildings.
//      {
//        if(isThreat || !threatFound){
//          mindist = dist;
//          target = unit;
//          if(isThreat)
//            threatFound = true;
//        }
//      }
//    }
//    return target;
//}
//
//
//BWAPI::Unit* UnitAttackFSM::selectDragoonTarget(UnitGroup enemies)
//{
//
//    int minhp = boost::numeric::bounds<int>::highest();
//    int mindist = boost::numeric::bounds<int>::highest();
//    bool threatFound = false;
//    BWAPI::Unit* target = NULL;
//
//    for(UnitGroup::const_iterator i=enemies.begin(); i!=enemies.end(); ++i)
//    {
//      BWAPI::Unit* unit = *i;
//      if(!unit->isVisible(BWAPI::Broodwar->self()))
//        continue;
//      int hp = unit->getHitPoints() + unit->getShields();
//      int dist = unit->getDistance(m_unit->getPosition());
//      //not a threat if the unit is a worker or if the unit is a building that cannot attack
//      bool isThreat = !(unit->getType().isWorker() || (unit->getType().isBuilding() && !unit->getType().canAttack()));
//
//      if ((hp  < minhp) ||                       
//          (hp == minhp  && dist < mindist))
//      {
//        if(isThreat || !threatFound){
//          minhp = hp;
//          mindist = dist;
//          target = unit;
//          if(isThreat)
//            threatFound = true;
//        }
//      }
//    }
//    return target;
//}
