#pragma once
#include "../../../../Utils/FSM/Condition.h"

class BuildingStarted : public Condition
{
public:
  BuildingStarted(BWAPI::TilePosition target, BWAPI::UnitType type)
    : m_target(target),
      m_type(type)
  {
  }

  bool evaluate() const
  {
    std::set<BWAPI::Unit*> units = BWAPI::Broodwar->getUnitsOnTile(m_target.x(),m_target.y());
    for(std::set<BWAPI::Unit*>::iterator it = units.begin() ; it!=units.end() ; ++it)
    {
      if((*it)->getType() == m_type)
        return true;
    }
    return false;
  }

protected:
  const BWAPI::TilePosition m_target;
  const BWAPI::UnitType m_type;
};
