#include "stdafx.h"
#include "Dodge.h"
#include "../Layer1FSM.h"
#include <stdlib.h>
#include <string>

///////////////////////////////////////////////////
// Unit in safe State

Dodge::Safe::Safe(Dodge& behavior)
  : BehaviorState(behavior)  
  , m_timerEvent(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 5, 5)
  , m_transition(
	  *this,
	  HasCriticalHealth(behavior.m_unit),
	  NoTransitionAction(),
	  behavior.m_criticalState)
  , m_events(m_timerEvent)
  , m_transitions(m_transition)
{
}

void Dodge::Safe::onEnterImpl()
{
}

void Dodge::Safe::onExitImpl()
{
}

///////////////////////////////////////////////////
// Unit in critical State

Dodge::Critical::Critical(Dodge& behavior)
  : BehaviorState(behavior)
  , m_moveAction(*this)
  , m_timerEvent(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 10, 10)
  , m_transitionToSelf(
	  *this,
	  InDanger(behavior.m_unit),
	  NoTransitionAction(),
	  *this)
  , m_transitionToSafeState(
    *this,
    Not<ShouldBeDodging>(ShouldBeDodging(HasCriticalHealth(behavior.m_unit), InDanger(behavior.m_unit))),
    NoTransitionAction(), 
    behavior.m_safeState)
  , m_events(m_timerEvent)
  , m_transitions(m_transitionToSelf,m_transitionToSafeState)
{
}

void Dodge::Critical::onEnterImpl()
{
  BWAPI::Position destination = Spar->getPerceptualState().getSafeDodgePosition(m_context.m_unit);
  m_moveAction.setDestination(destination);
  Layer1FSM::getInstance().getArbitrator().submitAction(m_context.m_unit, m_moveAction, Arbitration::ActionImportance(*this));
}

void Dodge::Critical::onExitImpl()
{
}