#include "stdafx.h"
#include "GroupCarefulAttack.h"
#include <BWAPI.h>

///////////////////////////////////////////////////
// Engaging state
///////////////////////////////////////////////////

GroupCarefulAttack::Engaging::Engaging(GroupCarefulAttack& behavior)
  : BehaviorState(behavior)
  , m_enemyUnitDestroyedEventHandler(*this)
  , m_events(/*m_enemyUnitInLocationEvent*/)
  , m_transitions()
{
}

void GroupCarefulAttack::Engaging::onEnterImpl()
{
  m_context.m_enemyUnits = Spar->getPerceptualState().getEnemyUnits(RectangularGroupDynamicLocation(m_context.getGroup()));
  for(PersistentUnitGroup::const_iterator it=m_context.getGroup()->begin(); it != m_context.getGroup()->end(); ++it)
  {
    BWAPI::Unit* unit = *it;
    UnitCarefulAttack* newBehavior = new UnitCarefulAttack(&m_context, m_context.getCurrentPriority() * 2 + 1,unit,m_context.getGroup());
    Process::zombifyOnTerminate(newBehavior);
    newBehavior->execute();
  }
  findTarget();
  setTarget();
}

void GroupCarefulAttack::Engaging::onEnemyUnitDestroyed(void* data)
{
  m_context.m_enemyUnits = Spar->getPerceptualState().getEnemyUnits(RectangularGroupDynamicLocation(m_context.getGroup()));
  findTarget();
  setTarget();
}

void GroupCarefulAttack::Engaging::findTarget()
{
  BWAPI::Unit* nextTarget = NULL;
  if (m_context.m_enemyUnits.size() > 0)
  {
    BWAPI::Position center = m_context.getGroup()->getCenter();
    //BWAPI::Unit* nextTarget =  m_context.m_enemyUnits.getWeakest();
    //if(!nextTarget)
    nextTarget = m_context.m_enemyUnits.getNearest(center);
  }
  if(!!nextTarget)
  {
    m_context.m_target = nextTarget;
    Spar->getUnitManager().subscribeIndividualUnitDestroy(m_context.m_target, &m_enemyUnitDestroyedEventHandler,0);  //TODO: Unsubscribe or the world will explode
  }
}

void GroupCarefulAttack::Engaging::setTarget()
{
  if(!!m_context.m_target)
  {
    m_context.for_each_sub_behavior(SetTarget(m_context.m_target));
  }
}