#pragma once
#include "../../../Behaviors/EngageEnemies/EngageEnemies.h"

class SplitGroupCarefulAttack : public EngageEnemies<SplitGroupCarefulAttack>
{
protected:
  //class Engaging;
  //friend class Engaging;

  /**
  * @brief The Engaging state is active when the group is engaging the enemies.
  *        New sub-behaviors are spawned upon entering this state.
  */
  class Engaging : public BehaviorState<SplitGroupCarefulAttack, Engaging>
  {
  public:
    Engaging(SplitGroupCarefulAttack& behavior, const UnitGroup& enemyUnits);
    void onEnterImpl();
    void onExitImpl();

    typedef boost::tuple<
    > Events;
		const Events m_events;

    typedef boost::tuple<
    > Transitions;
		const Transitions m_transitions;

  protected:
    // Variables
    const BWAPI::Position m_enemyCenter;
    ProcessContainer<IGroupBehavior> m_groupBehavior;

    // Actions

    // Transitions
  };

public:
  SplitGroupCarefulAttack(const Process* parent, unsigned int initialPriority, const PersistentUnitGroup* group, const UnitGroup& enemyUnits)
    : EngageEnemies(parent, initialPriority, group)
    , IEngageEnemies(parent, initialPriority, group)
    , IGroupBehavior(parent, initialPriority, group)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
    , m_engagingState(*this, enemyUnits)
    , m_states(m_engagingState)
  {
  }

  virtual std::string getName() const
  {
    return "SplitGroupCarefulAttack";
  }

  virtual void onUnitAddedToGroup(void* data, BWAPI::Unit* unit)
  {
    // TODO
  }

  virtual void onUnitRemovedFromGroup(void* data, BWAPI::Unit* unit)
  {
    // TODO
  }

  typedef boost::tuple<
      Engaging&
    > States;
	const States m_states;

protected:
  virtual void executeImpl()
  {
    EngageEnemies::executeImpl();
    m_engagingState.onEnter();
  }

  // Arguments

  // Variables

  // States
  Engaging m_engagingState;
};
