#include "stdafx.h"
#include "MeleeEngage.h"
#include "../../Layer1FSM.h"
#include <BWAPI.h>

///////////////////////////////////////////////////
// Engaging state
///////////////////////////////////////////////////

MeleeEngage::Engaging::Engaging(MeleeEngage& behavior)
  : BehaviorState(behavior)
  , m_unitDestroyedEventHandler(*this)
  , m_attackMoveAction(*this)
  , m_timerEvent(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 10, 10)
  /*, m_transitionToSelf(
      *this,
      m_enemyUnitsInLocationEvent,
      NoCondition(), 
      NoTransitionAction(),
      *this)*/
  , m_events(m_timerEvent)
  , m_transitions(/*m_transitionToSelf*/)
{
}

MeleeEngage::Engaging::~Engaging()
{
}

void MeleeEngage::Engaging::prepare()
{
  m_context.m_enemyUnits = Spar->getPerceptualState().getEnemyUnits(RectangularGroupDynamicLocation(m_context.getGroup()));
}

void MeleeEngage::Engaging::onEnterImpl()
{
  if (m_context.m_enemyUnits.size() == 0)
    m_context.terminate(Behavior::Success);
  else
    findTargetAndFire();
}

void MeleeEngage::Engaging::onTimer()
{
  m_context.m_enemyUnits = Spar->getPerceptualState().getEnemyUnits(RectangularGroupDynamicLocation(m_context.getGroup()));

  if (m_context.m_enemyUnits.size() == 0)
    m_context.terminate(Behavior::Success);
  else
    findTargetAndFire();
}

void MeleeEngage::Engaging::onUnitDestroyed(void* data)
{
  if (m_context.m_enemyUnits.size() == 0)
    m_context.terminate(Behavior::Success);
  else
    findTargetAndFire();
}

void MeleeEngage::Engaging::findTargetAndFire()
{
	BWAPI::Position center = m_context.getGroup()->getCenter();
  BWAPI::Unit* nearestEnemyUnit = m_context.m_enemyUnits.getNearest(center);
	
	Spar->getUnitManager().subscribeIndividualUnitDestroy(nearestEnemyUnit, &m_unitDestroyedEventHandler,0);

	m_attackMoveAction.setDestination(nearestEnemyUnit->getPosition());

  Layer1FSM::getInstance().getArbitrator().
      submitAction(m_context.getGroup(), m_attackMoveAction, Arbitration::ActionImportance(*this));
}

void MeleeEngage::Engaging::onExitImpl()
{
}