#pragma once
#include "../../Behaviors/EngageEnemies/EngageEnemies.h"
#include "../../../../../PerceptualState/Locations/Dynamic/RectangularGroupDynamicLocation.h"
#include "../../Conditions/AtLeastOneUnit.h"

class AttackMoveAction;

// This behavior is probably full of bugs; it should be adapted to our framework before being used

class MeleeEngage : public EngageEnemies<MeleeEngage>
{
protected:
  class Engaging;
  friend class Engaging;

  class Engaging : public BehaviorState<MeleeEngage, Engaging>
  {
  public:
    Engaging(MeleeEngage& behavior);
    ~Engaging();
    void prepare();
    void onEnterImpl();
    void onExitImpl();

    //Public Callbacks
    void onUnitDestroyed(void* data);
    void onTimer();

    typedef SCHEDULER_EVENT(Engaging, onTimer) TimerEvent;

    typedef boost::tuple<
      TimerEvent&
    > Events;
		const Events m_events;

    typedef boost::tuple<
      //Transition<Engaging, NoCondition, NoTransitionAction, Engaging>&
    > Transitions;
		const Transitions m_transitions;

  protected:
    void findTargetAndFire();

    // Variables

    // Callback functors
    EVENT_HANDLER(Engaging, onUnitDestroyed) m_unitDestroyedEventHandler;

    // Actions
    layer1::AttackMoveAction m_attackMoveAction;

    // Transitions
    TimerEvent m_timerEvent;
    //Transition<Engaging, NoCondition, NoTransitionAction, Engaging> m_transitionToSelf;
  };

public:
  MeleeEngage(const Process* parent, unsigned int initialPriority, const PersistentUnitGroup* group)
    : EngageEnemies(parent, initialPriority, group)
    , IEngageEnemies(parent, initialPriority, group)
    , IGroupBehavior(parent, initialPriority, group)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
    , m_engagingState(*this)
    , m_states(m_engagingState)
  {
  }

  virtual std::string getName() const
  {
    return "MeleeEngage";
  }

  virtual void onUnitAddedToGroup(void* data, BWAPI::Unit* unit)
  {
    // TODO
  }

  virtual void onUnitRemovedFromGroup(void* data, BWAPI::Unit* unit)
  {
    // TODO
  }

  typedef boost::tuple<
      Engaging&
    > States;
	const States m_states;

protected:
  virtual void executeImpl()
  {
    EngageEnemies::executeImpl();
    m_engagingState.onEnter();
  }

  // Arguments

  // Variables
  UnitGroup m_enemyUnits;

  // States
  Engaging m_engagingState;
};
