#include "stdafx.h"
#include "ObserverScout.h"
#include "../Layer1FSM.h"

ObserverScout::GoToEnemy::GoToEnemy(ObserverScout& behavior) 
: BehaviorState(behavior)
, m_moveAction(*this)
, m_destinationReached(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 1, 1)
, m_transitionToSelf(*this,
                     NoCondition(), 
                     NoTransitionAction(), 
                     *this)
, m_events(m_destinationReached)
, m_transitions(m_transitionToSelf)
{}

void ObserverScout::GoToEnemy::onEnterImpl()
{
  m_moveAction.setDestination(m_context.m_enemyLocation);
  Layer1FSM::getInstance().getArbitrator().submitAction(m_context.m_unit, m_moveAction, Arbitration::ActionImportance(*this));
}

void ObserverScout::GoToEnemy::onExitImpl()
{}