#pragma once
#include "../UnitBehavior.h"
#include "../BehaviorState.h"
#include "../Arbitrator.h"

// Observer Scouting behaviour 
// TODO: NOT FINISHED!  Should scout a location while avoiding detection.
// Currently only goes to the location
class ObserverScout : public UnitBehavior<ObserverScout>
{
  class GoToEnemy;
  //class Explore;
  //class AvoidDetect;
  friend class GoToEnemy;
  //friend class Explore;
  //friend class AvoidDetect;
  
  class GoToEnemy : public BehaviorState<ObserverScout, GoToEnemy>
  {
  public:
    GoToEnemy(ObserverScout& behavior);
    void onEnterImpl();
		void onExitImpl();

    void onTimer()
    {
      m_transitionToSelf.testTransition(boost::make_tuple());
    }

    typedef SCHEDULER_EVENT(GoToEnemy, onTimer) TimerEvent;

    typedef boost::tuple<
          TimerEvent&
          > Events;
		Events m_events;
    
		typedef boost::tuple<
          Transition<GoToEnemy, NoCondition, NoTransitionAction, GoToEnemy>&
		  > Transitions;
		Transitions m_transitions;

	protected:
    // Actions
		//StopAction m_stopAction;
		layer1::MoveAction m_moveAction;

    //temp event and transition
    TimerEvent m_destinationReached;
		Transition<GoToEnemy, NoCondition, NoTransitionAction, GoToEnemy> m_transitionToSelf;
  };

  
public:
  ObserverScout(const Process* parent, unsigned int initialPriority, BWAPI::Position enemyLocation, BWAPI::Unit* scoutingUnit)
    : UnitBehavior(parent, initialPriority, scoutingUnit)
    , IUnitBehavior(parent, initialPriority, scoutingUnit)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
    , m_goToEnemyState(*this)
    , m_enemyLocation(enemyLocation)
    , m_states(m_goToEnemyState)
  {}

  virtual std::string getName() const
  {
    return "ObserverScout (" + getObjectDescription(m_unit) + ")";
  }

  typedef boost::tuple<
      GoToEnemy&
    > States;
	const States m_states;

protected:
  virtual void executeImpl()
  {
    UnitBehavior::executeImpl();
    m_goToEnemyState.onEnter();
  }

  // Arguments

  // Variables
  BWAPI::Position m_enemyLocation;

  // States
  GoToEnemy m_goToEnemyState;
};