#include "stdafx.h"
#include "Wander.h"
#include "../Layer1FSM.h"
#include <time.h>

//------------------------------------------------------------------------------
// Going state
//------------------------------------------------------------------------------
Wander::Going::Going(Wander& behavior)
  : BehaviorState(behavior)
  , m_moveAction(*this)
  , m_destinationReached(*this, Scheduler::FSM_SCHEDULING_PRIORITY, 5, 5)
  , m_transitionToSelf(
      *this,
	    IsUnitIdle(behavior.m_unit),
      NoTransitionAction(),
      *this)
  , m_events(m_destinationReached)
  , m_transitions(m_transitionToSelf)
{
}

void Wander::Going::onEnterImpl()
{ 
  srand(static_cast<unsigned int>(time(NULL)));
  double randx = (rand() % 400) + 25; 
  double randy = (rand() % 400) + 25;
  if((rand() % 100) > 50){
    randx = randx * -1;
  }
  if((rand() % 100) > 50){
    randy = randy * -1;
  }
  int x = static_cast<int>(m_context.m_unit->getPosition().x() + randx);
  int y = static_cast<int>(m_context.m_unit->getPosition().y() + randy);
  BWAPI::Position destination = BWAPI::Position(x,y);
  m_moveAction.setDestination(destination);
  Layer1FSM::getInstance().getArbitrator().
    submitAction(m_context.m_unit, m_moveAction, Arbitration::ActionImportance(*this));
}
