#pragma once
#include "../UnitBehavior.h"
#include "../BehaviorState.h"
#include "../Arbitrator.h"
#include "../Conditions/IsIdle.h"

class Wander : public UnitBehavior<Wander>
{
protected:
	class Going;
	friend class Going;

	class Going : public BehaviorState<Wander, Going>
	{
	public:
		Going(Wander& behavior);
		void onEnterImpl();
		void onExitImpl() {}

    void onTimer()
    {
      m_transitionToSelf.testTransition(boost::make_tuple());
    }

    typedef SCHEDULER_EVENT(Going, onTimer) TimerEvent;

		typedef boost::tuple<
          TimerEvent&
          > Events;
		const Events m_events;
    
		typedef boost::tuple<
          Transition<Going, IsUnitIdle, NoTransitionAction, Going>&
		  > Transitions;
		const Transitions m_transitions;

	protected:
    // Variables

    // Actions
		//StopAction m_stopAction;
		layer1::MoveAction m_moveAction;

    // Transitions
    TimerEvent m_destinationReached;
		Transition<Going, IsUnitIdle, NoTransitionAction, Going> m_transitionToSelf;
	};

public:
  Wander(const Process* parent, unsigned int initialPriority, BWAPI::Unit* wanderUnit)
    : UnitBehavior(parent, initialPriority, wanderUnit)
    , IUnitBehavior(parent, initialPriority, wanderUnit)
    , IBehavior(parent, initialPriority)
    , IFSM(parent)
    , Process(parent)
    , m_goingState(*this)
    , m_states(m_goingState)
  {
  }

  virtual std::string getName() const
  {
    return "Wander (" + getObjectDescription(m_unit) + ")";
  }

  typedef boost::tuple<
      Going&
    > States;
	const States m_states;

protected:
  virtual void executeImpl()
  {
    UnitBehavior::executeImpl();
    m_goingState.onEnter();
  }

  // Arguments

  // Variables
  
  // States
  Going m_goingState;
};


