#pragma once
#include "../../../Utils/Resources.h"
#include "../../../PerceptualState/Locations/Static/StaticLocation.h"

class ActionResources
{
public:
  ActionResources()
    : m_buildingLocation(NULL)
    , m_buildingType(BWAPI::UnitTypes::None)
  {}
  ActionResources(int minerals, int gas, int supply)
    : m_resources(static_cast<double>(minerals), 
                  static_cast<double>(gas),
                  static_cast<double>(supply))
    , m_buildingLocation(NULL)
    , m_buildingType(BWAPI::UnitTypes::None)
  {}
  ActionResources(const Resources& resources)
    : m_resources(resources)
    , m_buildingLocation(NULL)
    , m_buildingType(BWAPI::UnitTypes::None)
  {}
  ActionResources(int minerals, int gas, int supply, StaticLocation* buildingLocation, BWAPI::UnitType buildingType)
    : m_resources(static_cast<double>(minerals), 
                  static_cast<double>(gas),
                  static_cast<double>(supply))
    , m_buildingLocation(buildingLocation)
    , m_buildingType(buildingType)
  {}
  ActionResources(const Resources& resources, StaticLocation* buildingLocation, BWAPI::UnitType buildingType)
    : m_resources(resources)
    , m_buildingLocation(buildingLocation)
    , m_buildingType(buildingType)
  {}

  
  bool operator==(const ActionResources& resources)
  {
    return (resources.m_resources == m_resources && resources.m_buildingLocation == m_buildingLocation);
  }

  double getMinerals() const
  {
    return m_resources.getMinerals();
  }

  double getGas() const
  {
    return m_resources.getGas();
  }

  double getSupply() const
  {
    return m_resources.getSupply();
  }

  Resources getResources() const
  {
    return m_resources;
  }

  StaticLocation* getBuildingLocation() const
  {
    return m_buildingLocation;
  }

  BWAPI::UnitType getBuildingType() const
  {
    return m_buildingType;
  }

protected:
  Resources m_resources;
  StaticLocation* m_buildingLocation;
  BWAPI::UnitType m_buildingType;
};