#pragma once
#include "GroupTacticalAction.h"

namespace layer2
{
  class AttackMove : public virtual GroupTacticalAction
  {
  public:
    AttackMove(unsigned int priority, const PersistentUnitGroup* initialGroup, Location* location)
      : GroupTacticalAction(priority, initialGroup)
      , TacticalAction(priority)
      , Process(Spar)
      , m_location(location)
    {
    }

    virtual std::string getName() const
    {
      return "AttackMove";
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      GroupTacticalAction::output(out);

      out << "Attack-Move(" << getGroup()->getName() << ", " << *m_location << ")";
    }

    Location* const m_location;
  };
}
