#pragma once
#include "GroupTacticalAction.h"
#include "../../../../PerceptualState/Locations/Static/BaseLocation.h"

namespace layer2
{
  class Collect : public virtual GroupTacticalAction
  {
  public:
    Collect(unsigned int priority, const PersistentUnitGroup* initialGroup, BaseLocation* baseLocation)
      : GroupTacticalAction(priority, initialGroup)
      , TacticalAction(priority)
      , Process(Spar)
      , m_baseLocation(baseLocation)
    {
    }

  public:
    BaseLocation* getMiningLocation() const
    {
      return m_baseLocation;
    }

  protected:
    BaseLocation* const m_baseLocation;
  };

  class CollectMinerals : public virtual Collect
  {
  public:
    CollectMinerals(unsigned int priority, const PersistentUnitGroup* initialGroup, BaseLocation* baseLocation)
      : Collect(priority, initialGroup, baseLocation)
      , GroupTacticalAction(priority, initialGroup)
      , TacticalAction(priority)
      , Process(Spar)
    {
    }

    virtual std::string getName() const
    {
      return "CollectMinerals";
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      Collect::output(out);
      out << "Collect-Minerals(" << getGroup()->getName() << ", " << *m_baseLocation << ")";
    }
  };

  class CollectGas : public virtual Collect
  {
  public:
    CollectGas(unsigned int priority, const PersistentUnitGroup* initialGroup, BaseLocation* baseLocation)
      : Collect(priority, initialGroup, baseLocation)
      , GroupTacticalAction(priority, initialGroup)
      , TacticalAction(priority)
      , Process(Spar)
    {
    }

    virtual std::string getName() const
    {
      return "CollectGas";
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      Collect::output(out);
      out << "CollectGas(" << getGroup()->getName() << ", " << *m_baseLocation << ")";
    }
  };
}