#pragma once
#include "GroupTacticalAction.h"

namespace layer2
{
  class Move : public virtual GroupTacticalAction
  {
  public:
    Move(unsigned int priority, const PersistentUnitGroup* initialGroup, Location* destination)
      : GroupTacticalAction(priority, initialGroup)
      , TacticalAction(priority)
      , Process(Spar)
      , m_destination(destination)
    {
    }

    virtual std::string getName() const
    {
      return "Move";
    }

    Location* getDestination()
    {
      return m_destination;
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      GroupTacticalAction::output(out);

      out << "Move(" << getGroup()->getName() << ", " << *m_destination << ")";
    }

    Location* const m_destination;
  };
}
