#pragma once
#include "TacticalAction.h"
#include "../../../../PerceptualState/Techs/Tech.h"

namespace layer2
{
  class Research : public virtual TacticalAction
  {
  public:
    Research(unsigned int priority)
      : TacticalAction(priority)
      , Process(Spar)
    {
    }
  };

  class UpgradeResearch : public virtual Research
  {
  public:
    UpgradeResearch(unsigned int priority, UpgradeTypeTech* upgrade)
      : Research(priority)
      , TacticalAction(priority)
      , Process(Spar)
      , m_upgrade(upgrade)
    {
    }

    virtual std::string getName() const
    {
      return "UpgradeResearch";
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      Research::output(out);

      out << "Upgrade-Research(" << *m_upgrade << ")";
    }

    UpgradeTypeTech* const m_upgrade;
  };

  class TechResearch : public virtual Research
  {
  public:
    TechResearch(unsigned int priority, TechTypeTech* tech)
      : Research(priority)
      , TacticalAction(priority)
      , Process(Spar)
      , m_tech(tech)
    {
    }

    virtual std::string getName() const
    {
      return "TechResearch";
    }

  protected:
    virtual void output(std::ostream& out) const
    {
      Research::output(out);

      out << "Tech-Research(" << *m_tech << ")";
    }

    TechTypeTech* const m_tech;
  };
}