#pragma once
#include "GroupTacticalAction.h"

namespace layer2
{
  class Scout : public virtual GroupTacticalAction
  {
  public:
    // TODO: PrimitiveLocation? or allow CompositeLocation as well?
    Scout(unsigned int priority, StaticLocation* location)
      : GroupTacticalAction(priority)
      , TacticalAction(priority)
      , Process(Spar)
      , m_location(location)
    {}

    virtual std::string getName() const
    {
      return "Scout";
    }

    DECLARE_EVENT3(OnScoutArrived, const Scout*, StaticLocation*,BWAPI::Unit*);
    OnScoutArrived& getScoutArrivedEvent() const { return m_scoutArrivedEvent; }

    DECLARE_EVENT3(OnLocationScouted, const Scout*, PrimitiveLocation*,BWAPI::Unit*);
    OnLocationScouted& getLocationScoutedEvent() const { return m_locationScoutedEvent; }

  protected:
    virtual void output(std::ostream& out) const
    {
      TacticalAction::output(out);

      out << "Scout(" << *m_location << ")";
    }

    StaticLocation* const m_location;

    EVENT(OnScoutArrived) m_scoutArrivedEvent;
    EVENT(OnLocationScouted) m_locationScoutedEvent;
  };
}
