#pragma once
#include "../../../Utils/Utils.h"
#include "../../PerceptualState/Common.h"
#include "Interface/Common.h"
#include <BWAPI.h>

class Layer2ActionsBase
{
public:
  Layer2ActionsBase()
  {
    s_instance = this;
  }

  DECLARE_EVENT2(OnUnitIdle, BWAPI::Unit*, const layer2::GroupTacticalAction*); // The unit released and the previous action
  OnUnitIdle& getUnitIdleEvent() const { return m_unitIdleEvent; }

  static Layer2ActionsBase& getInstance()
  {
    return *s_instance;
  }

private:
  static Layer2ActionsBase* s_instance;

  EVENT(OnUnitIdle) m_unitIdleEvent;
};

template <class Layer2Cueing, class Layer1Reactive>
class Layer2Actions : public Layer2ActionsBase, public Component
{
public:
  //
  // Default location types matching
  //
  template <class LocationType>
  struct LocationTypes {};
  template <>
  struct LocationTypes<AirLocation> {
    typedef empty<Layer2Actions> Type;
  };
  template <>
  struct LocationTypes<BaseLocation> {
    typedef empty<Layer2Actions> Type;
  };
  template <>
  struct LocationTypes<Chokepoint> {
    typedef empty<Layer2Actions> Type;
  };
  template <>
  struct LocationTypes<Region> {
    typedef empty<Layer2Actions> Type;
  };
  template <>
  struct LocationTypes<RegionLocation> {
    typedef empty<Layer2Actions> Type;
  };
  template <>
  struct LocationTypes<Map> {
    typedef empty<Layer2Actions> Type;
  };

  typedef Layer2UnitData L2UnitData;

  Layer2Actions(Layer2Cueing& layer2Cueing, Layer1Reactive& layer1Reactive)
    : m_layer2Cueing(layer2Cueing)
    , m_layer1Reactive(layer1Reactive)
  {
  }

  void onStart() {}
  void onFrame() {}
  void onEnd() {}
  void onSendText(std::string text) {}

protected:
  Layer2Cueing& m_layer2Cueing;
  Layer1Reactive& m_layer1Reactive;
};
