#pragma once
#include "../../Interface/Actions/Attack.h"
#include "L2GroupTacticalAction.h"

class L2Attack : public virtual layer2::Attack, public L2GroupTacticalAction
{
public:
  L2Attack(unsigned int priority, const PersistentUnitGroup* initialGroup) // TODO: target
    : Attack(priority, initialGroup)
    , L2GroupTacticalAction(priority, initialGroup)
    , GroupTacticalAction(priority, initialGroup)
    , TacticalAction(priority)
    , Process(Spar)
  {
  }

protected:
  virtual void executeSpecificImpl();
  virtual void cancelSpecificImpl();
  virtual void terminateSpecificImpl();

  virtual void output(std::ostream& out) const
  {
    Attack::output(out);

    out << "Attack(" << getGroup()->getName() << ")";
  }

  virtual void onUnitAddedToGroup(void*, BWAPI::Unit* unit);
  virtual void onUnitRemovedFromGroup(void*, BWAPI::Unit* unit);
};

