#include "stdafx.h"
#include "L2AttackMove.h"
#include "../Layer2Managers.h"

void L2AttackMove::executeSpecificImpl()
{
  m_event.activate();
  L2GroupTacticalAction::executeSpecificImpl();
  //getGroup()->attackMove(m_target);
  m_groupAttackFSM = new GroupAttack(this, 100, getGroup(), new CoordinatesLocation(m_target));
  m_groupAttackFSM->execute();
}

void L2AttackMove::cancelSpecificImpl()
{
  L2GroupTacticalAction::cancelSpecificImpl();
  terminate(Cancelled);
}

void L2AttackMove::terminateSpecificImpl()
{
  if(m_groupAttackFSM != NULL)
    m_groupAttackFSM->externalTerminate();
  L2GroupTacticalAction::terminateSpecificImpl();
}

void L2AttackMove::onUnitAddedToGroup(void*, BWAPI::Unit* unit)
{
  // TODO
  //newUnit++;
  //if(newUnit==12)
  //{
  //  getGroup()->attackMove(m_target);
  //  newUnit=0;
  //}
}
void L2AttackMove::onUnitRemovedFromGroup(void*, BWAPI::Unit* unit)
{
  // TODO
}

void L2AttackMove::onTimeout()
{
  if(m_groupAttackFSM==NULL)
  {
    // TODO: get the termination mode from the FSM
    terminate(Success);
  } else {
    //If 1 unit is idle at target
    std::set<BWAPI::Unit*> units = BWAPI::Broodwar->getUnitsInRadius(m_target,3*TILE_SIZE);
    bool idleUnit = false;
    bool actionEnded = false;
    for(std::set<BWAPI::Unit*>::const_iterator it = units.begin() ; it != units.end() ; ++it)
    {
      if(getGroup()->find(*it) != getGroup()->end())
      {
        if((*it)->isIdle())
        {
          idleUnit = true;
        }
      }
    }
    //find new target
    if(idleUnit)
    {
      if(static_cast<StaticLocation*>(m_location))
      {
        StaticLocation* sl = static_cast<StaticLocation*>(m_location);
        std::pair<StaticLocation::enemy_building_const_iterator,StaticLocation::enemy_building_const_iterator> eBuildings = sl->getEnemyBuildings();
        if(eBuildings.first == eBuildings.second)
        {
          std::pair<StaticLocation::enemy_unit_const_iterator,StaticLocation::enemy_unit_const_iterator> eUnits = sl->getEnemyUnits();
          {
            if(eBuildings.first == eBuildings.second)
            {
              actionEnded = true;
            }
            else
            {
              m_target = (*eUnits.first)->getPosition();
              m_groupAttackFSM->externalTerminate();
              m_groupAttackFSM = new GroupAttack(this, 100, getGroup(), new CoordinatesLocation(m_target));
              m_groupAttackFSM->execute();             
            }
          }     
        }
        else
        {
          m_target = (*eBuildings.first)->getPosition();
          m_groupAttackFSM->externalTerminate();
          m_groupAttackFSM = new GroupAttack(this, 100, getGroup(), new CoordinatesLocation(m_target));
          m_groupAttackFSM->execute(); 
          //getGroup()->attackMove(m_target);
        }
      }
      else
      {
        actionEnded = true;
      }
    }
    //if no new target action terminated
    if(actionEnded)
    {
      terminate(Success);
    }
    //If new not terminated reactivte on timeout
    else
    {
      m_event.activate();
    }
  }
}