#pragma once
#include "../../Interface/Actions/AttackMove.h"
#include "../../../Layer1Reactive/FSM/Behaviors/EngageEnemies/GroupAttack.h"
#include "L2GroupTacticalAction.h"

class L2AttackMove : public virtual layer2::AttackMove, public L2GroupTacticalAction
{
public:
  L2AttackMove(unsigned int priority, const PersistentUnitGroup* initialGroup, Location* location)
    : AttackMove(priority, initialGroup, location)
    , L2GroupTacticalAction(priority, initialGroup)
    , GroupTacticalAction(priority, initialGroup)
    , TacticalAction(priority)
    , Process(Spar)
    , m_event(*this,priority,0,30)
    , m_groupAttackFSM(*this)
  {
    if(static_cast<StaticLocation*>(location))
    {
      StaticLocation* sl = static_cast<StaticLocation*>(location);
      std::pair<StaticLocation::enemy_building_const_iterator,StaticLocation::enemy_building_const_iterator> eBuildings = sl->getEnemyBuildings();
      if(eBuildings.first == eBuildings.second)
      {
        m_target =  sl->getCurrentCenter();
      }
      else
      {
        m_target = (*eBuildings.first)->getPosition();
      }
    }
    else
    {
      m_target = location->getCurrentCenter();
    }
    newUnit = 0;
  }

  Location* getTargetLocation()
  {
    return m_location;
  }

  void onTimeout();

protected:
  BWAPI::Position m_target;
  int newUnit;

  virtual void executeSpecificImpl();
  virtual void cancelSpecificImpl();
  virtual void terminateSpecificImpl();

  virtual void onUnitAddedToGroup(void*, BWAPI::Unit* unit);
  virtual void onUnitRemovedFromGroup(void*, BWAPI::Unit* unit);

  SCHEDULER_EVENT(L2AttackMove,onTimeout) m_event;

private:
  ProcessContainer<GroupAttack> m_groupAttackFSM;
};
