#pragma once
#include <BWAPI.h>
#include "../../../PerceptualState/Locations/Static/StaticLocation.h"
#include "../../../PerceptualState/Locations/Static/BaseLocation.h"

class NewBuildingPlacer
{
public:
  static void onStart()
  {
    s_newBuildingPlacer = new NewBuildingPlacer();
  }
  static void onEnd()
  {
    delete s_newBuildingPlacer;
  }
  static NewBuildingPlacer* getInstance()
  {
    return s_newBuildingPlacer;
  }
  void setBuildingDistance(int dist);

  bool needsAdditionalPylons();
  void setPylonFalse();

  //Should need only base in the future
  BWAPI::TilePosition getBuildingLocation(BWAPI::Unit* builder, BWAPI::UnitType toBuild,StaticLocation* location);
  bool reservePosition(BWAPI::TilePosition tp,BWAPI::UnitType toBuild);
  bool unreservePosition(BWAPI::TilePosition tp,BWAPI::UnitType toBuild);
  void addNewNexus(BWAPI::Unit* nexus);
  
  //Should not be here
  bool isUsed(BWAPI::Unit*);
  void useWorker(BWAPI::Unit*);
  void releaseWorker(BWAPI::Unit*);
private:
  NewBuildingPlacer();
  ~NewBuildingPlacer();
  bool overReservedPosition(BWAPI::TilePosition tp,BWAPI::UnitType toBuild);
  bool canBuildHere(BWAPI::Unit* builder, BWAPI::TilePosition position, BWAPI::UnitType type);
  bool canBuildHereWithSpace(BWAPI::Unit* builder, BWAPI::TilePosition position, BWAPI::UnitType type, int buildDist);
  bool buildable(BWAPI::Unit* builder, int x, int y);
  bool tileHasBuilding(BWAPI::TilePosition position);
  bool tileIsWalkable(BWAPI::TilePosition position);
  bool canWalkAround(BWAPI::TilePosition position, BWAPI::UnitType type);
  BWAPI::TilePosition getBuildLocationNear(BWAPI::Unit* builder, BWAPI::TilePosition position, BWAPI::UnitType type, int buildDist, int maxDistance);
  
  static NewBuildingPlacer* s_newBuildingPlacer;

  int m_distance;
  bool** reservedEmplacements;
  std::list<BWAPI::Unit*> usedWorker;
  bool needPylon;
  std::set<BWAPI::Unit*> nexusWithoutPylon;
};