#pragma once
#include "../../../Utils/Utils.h"
#include "../../PerceptualState/Common.h"
#include "Interface/ArmyComposition.h"
#include "Interface/TechSet.h"
#include <BWAPI.h>

template <class Layer3TacticalRecognition, class Layer2Actions>
class Layer3Tactical : public Component
{
public:
  //
  // Default location types matching
  //
  template <class LocationType>
  struct LocationTypes {};
  template <>
  struct LocationTypes<AirLocation> {
    typedef empty<Layer3Tactical> Type;
  };
  template <>
  struct LocationTypes<BaseLocation> {
    typedef empty<Layer3Tactical> Type;
  };
  template <>
  struct LocationTypes<Chokepoint> {
    typedef empty<Layer3Tactical> Type;
  };
  template <>
  struct LocationTypes<Region> {
    typedef empty<Layer3Tactical> Type;
  };
  template <>
  struct LocationTypes<RegionLocation> {
    typedef empty<Layer3Tactical> Type;
  };
  template <>
  struct LocationTypes<Map> {
    typedef empty<Layer3Tactical> Type;
  };

  typedef empty<Layer3Tactical> L3UnitData;

  template <class TechType>
  struct TechTypes {};
  template <>
  struct TechTypes<UnitTypeTech> {
    typedef empty<Layer3Tactical> Type;
  };
  template <>
  struct TechTypes<TechTypeTech> {
    typedef empty<Layer3Tactical> Type;
  };
  template <>
  struct TechTypes<UpgradeTypeTech> {
    typedef empty<Layer3Tactical> Type;
  };

  Layer3Tactical(Layer3TacticalRecognition& layer3TacticalRecognition, Layer2Actions& layer2Actions)
    : m_layer3TacticalRecognition(layer3TacticalRecognition)
    , m_layer2Actions(layer2Actions)
  {
  }

  void onStart() {}
  void onFrame() {}
  void onEnd() {}
  void onSendText(std::string text) {}

  /////////
  // GUI //
  /////////
  ArmyComposition getTargetArmyComposition() const
  {
    return ArmyComposition();
  }
  TechSet getTargetTechs() const
  {
    return TechSet();
  }

protected:
  Layer3TacticalRecognition& m_layer3TacticalRecognition;
  Layer2Actions& m_layer2Actions;
};
