#include "stdafx.h"
#include "BuildGatewaysTask.h"
#include "../Layer3Script.h"

static const size_t MAX_SIMULTANEOUS_GATEWAYS = 2;

void BuildGatewaysTask::run()
{
  if (Layer2Managers::getInstance().getNbAvailableBuildings(BWAPI::UnitTypes::Protoss_Gateway, *Spar->getPerceptualState().getMap()) == 0
   && m_buildGateways.size() < MAX_SIMULTANEOUS_GATEWAYS) // 2 gateways max at once, which is an ad-hoc way to prevent some problems
  {
    const Resources surplus = m_layer3Script.getLayer2().getAvailableResources(PRIORITY_BUILD_GATEWAYS);
    if (surplus.getMinerals() >= BWAPI::UnitTypes::Protoss_Gateway.mineralPrice())
    {
      Build* buildGateway = new Build(
        PRIORITY_BUILD_GATEWAYS,
        Spar->getPerceptualState().getMap(), 
        BWAPI::UnitTypes::Protoss_Gateway);
      m_buildGateways.add(buildGateway);
      buildGateway->execute();
    }
  }
}
