#include "stdafx.h"
#include "BuildPylonsTask.h"
#include "../Layer3Script.h"
#include "../../../Layer2Actions/Managers/NewBuildingPlacer.h"

void BuildPylonsTask::run()
{
  const int supplyForOneRound = m_layer3Script.countSupplyForOneRoundTroops();
  const int supplyToAcquire = (BWAPI::Broodwar->self()->supplyUsed() + supplyForOneRound) -
                              (BWAPI::Broodwar->self()->supplyTotal() + m_buildPylons.size() * BWAPI::UnitTypes::Protoss_Pylon.supplyProvided());
  if (BWAPI::Broodwar->self()->supplyTotal() != MAX_SUPPLY &&
      supplyToAcquire >= 0)
  {
    const size_t nbPylons = (supplyToAcquire + BWAPI::UnitTypes::Protoss_Pylon.supplyProvided()) / BWAPI::UnitTypes::Protoss_Pylon.supplyProvided();
    for (size_t i = 0; i < nbPylons; ++i)
    {
      Build* build = new Build(
        PRIORITY_BUILD_PYLONS, 
        Spar->getPerceptualState().getMap(), 
        BWAPI::UnitTypes::Protoss_Pylon);
      m_buildPylons.add(build);
      build->execute();
    }
  }

  // TODO: fix; this breaks encapsulation (delete the include as well)
  if (Spar->getPerceptualState().getMap()->getNbCompletedOwnUnits(BWAPI::UnitTypes::Protoss_Pylon) > 0 && 
      m_buildPylons.size() == 0 && 
      NewBuildingPlacer::getInstance()->needsAdditionalPylons())
  {
    Build* build = new Build(
      PRIORITY_BUILD_PYLONS, 
      Spar->getPerceptualState().getMap(), 
      BWAPI::UnitTypes::Protoss_Pylon);
    m_buildPylons.add(build);
    build->execute();
  }
}
