#include "stdafx.h"
#include "InitialScoutTask.h"
#include "../Layer3Script.h"

void InitialScoutTask::run()
{
  m_hasAlreadyRun = true;

  Map* map = Spar->getPerceptualState().getMap();
  const std::set<BaseLocation*>& enemyPossibleStartLocations = map->getEnemyPossibleStartBaseLocations();

  BaseLocation* ownStartLocation = map->getOwnStartBaseLocation();

  // TODO: closer locations first
  for (std::set<BaseLocation*>::const_iterator it = enemyPossibleStartLocations.begin(); it != enemyPossibleStartLocations.end(); ++it)
  {
    m_baseLocationsToExplore.insert(m_baseLocationsToExplore.end(), *it);
  }

  BaseLocation* first = m_baseLocationsToExplore.front();
  m_baseLocationsToExplore.erase(m_baseLocationsToExplore.begin());

  executeScout(new Scout(PRIORITY_INITIAL_SCOUT, 
                         first));
}

void InitialScoutTask::executeScout(Scout* scout)
{
  m_scout = scout;
  m_scout->getLocationScoutedEvent().subscribe(&m_locationScoutedEventHandler, NULL);
  m_scout->getScoutArrivedEvent().subscribe(&m_scoutArrivedEventHandler, NULL);
  m_scout->execute();
}

void InitialScoutTask::onScoutArrived(void* data, const layer2::Scout* action, StaticLocation* arrivedAtLocation,BWAPI::Unit* unit)
{
  BaseLocation* destination = dynamic_cast<BaseLocation*>(arrivedAtLocation);
  if (destination != NULL)
  {
    if (destination->hasEnemyResourceDepot())
    {
      m_scout->cancel();
      executeScout(new Scout(PRIORITY_INITIAL_SCOUT,
                             destination->getParent()));
    }
    else
    {
      m_scout->cancel();
      if (!m_baseLocationsToExplore.empty())
      {
        BaseLocation* next = m_baseLocationsToExplore.front();
        m_baseLocationsToExplore.erase(m_baseLocationsToExplore.begin());

        executeScout(new Scout(PRIORITY_INITIAL_SCOUT, 
                               next));
      }
    }
  }
}

void InitialScoutTask::onLocationScouted(void* data, const layer2::Scout* action, PrimitiveLocation* scoutedLocation,BWAPI::Unit* unit)
{
  // Keep scouting: forever alone :-(
}
