#pragma once
#include "Layer3Task.h"

class InitialScoutTask : public Layer3Task
{
public:
  InitialScoutTask(Layer3Script& layer3Script)
    : Layer3Task(layer3Script)
    , m_scout(*this)
    , m_scoutArrivedEventHandler(*this)
    , m_locationScoutedEventHandler(*this)
    , m_hasAlreadyRun(false)
  {
  }

  void run();

  virtual void runV()
  {
    return run();
  }

  void onScoutArrived(void* data, const layer2::Scout* action, StaticLocation* arrivedAtLocation, BWAPI::Unit*);
  void onLocationScouted(void* data, const layer2::Scout* action, PrimitiveLocation* scoutedLocation, BWAPI::Unit*);
  void onScoutEnded(void* data, const layer2::TacticalAction* action);

  bool hasAlreadyRun() const
  {
    return m_hasAlreadyRun;
  }

protected:
  void executeScout(Scout* scout);

  EVENT_HANDLER3(InitialScoutTask, onScoutArrived, const layer2::Scout*, StaticLocation*, BWAPI::Unit*) m_scoutArrivedEventHandler; 
  EVENT_HANDLER3(InitialScoutTask, onLocationScouted, const layer2::Scout*, PrimitiveLocation*, BWAPI::Unit*) m_locationScoutedEventHandler;

  ProcessContainer<Scout> m_scout;
  std::list<BaseLocation*> m_baseLocationsToExplore;
  bool m_hasAlreadyRun;
};