#pragma once
#include "Layer3Task.h"

//
// Input: gas/mineral ratio
//

class ManageResourcesTask : public Layer3Task
{
public:
  ManageResourcesTask(Layer3Script& layer3Script)
    : Layer3Task(layer3Script)
    , m_targetResourcesRatio(1., 0.)
  {
  }

  void run();

  virtual void runV()
  {
    run();
  }

  void updateResourcesRatio(ResourcesAcquisitionRatio targetResourcesRatio)
  {
    m_targetResourcesRatio = targetResourcesRatio;
  }

  /////////
  // GUI //
  /////////
  ResourcesAcquisitionRatio getTargetResourcesRatio() const
  {
    return m_targetResourcesRatio;
  }

private:
  ProbesResourcesDistribution getTargetProbesResourcesDistribution(const ResourcesSaturation& saturation) const;

  ResourcesAcquisitionRatio m_targetResourcesRatio;
};
