#include "stdafx.h"
#include "RecruitArmyTask.h"
#include "../Layer3Script.h"

void RecruitArmyTask::run()
{
  //
  // Infinite recruit
  //
  bool executeInfiniteRecruit = false;
  if (m_infiniteRecruit == NULL)
  {
    executeInfiniteRecruit = true;
  }
  else if (m_infiniteRecruit->getUnitsToRecruit() != m_targetArmyComposition.getUnlimitedComposition())
  {
    // Could be m_infiniteRecruit->updateArmyComposition(...)
    m_infiniteRecruit->cancel();
    executeInfiniteRecruit = true;
  }
  if (executeInfiniteRecruit)
  {
    m_infiniteRecruit = new Recruit(PRIORITY_RECRUIT_ARMY, Spar->getPerceptualState().getMap(), m_targetArmyComposition.getUnlimitedComposition(), true);
    m_infiniteRecruit->getTerminateEvent().subscribe(&m_recruitTroopsEndedEventHandler, NULL);
    m_infiniteRecruit->getUnitRecruitedEvent().subscribe(&m_unitRecruitedEventHandler, NULL);
    m_infiniteRecruit->execute();
  }

  //
  // Finite recruits
  //
  const std::map<BWAPI::UnitType, size_t>& limitedComposition = m_targetArmyComposition.getLimitedComposition();
  for (std::map<BWAPI::UnitType, size_t>::const_iterator it = limitedComposition.begin(); it != limitedComposition.end(); ++it)
  {
    // TODO: cancel individual recruits if too many?
    std::pair<std::map<BWAPI::UnitType, ProcessContainerList<Recruit>>::iterator, bool> result = 
      m_finiteRecruits.insert(std::make_pair(it->first, ProcessContainerList<Recruit>(*this)));
    ProcessContainerList<Recruit>& list = result.first->second;
    for (size_t i = list.size(); i < it->second; ++i)
    {
      const unsigned int priority = it->first == BWAPI::UnitTypes::Protoss_Observer ? PRIORITY_RECRUIT_OBSERVER : PRIORITY_RECRUIT_ARMY;
      std::map<BWAPI::UnitType, size_t> oneUnit;
      oneUnit.insert(std::make_pair(it->first, 1));
      Recruit* recruit = new Recruit(priority, Spar->getPerceptualState().getMap(), oneUnit, false);
      recruit->getUnitRecruitedEvent().subscribe(&m_unitRecruitedEventHandler, NULL);
      list.add(recruit);
      recruit->execute();
    }
  }
}

void RecruitArmyTask::onRecruitTroopsEnded(void*)
{
  SPAR_LOG(LogTypes::GENERAL_ERROR, "ERROR RecruitArmyTask:onRecruitTroopsEnded(): infinite recruit should never end");

  m_infiniteRecruit = new Recruit(PRIORITY_RECRUIT_ARMY, Spar->getPerceptualState().getMap(), m_targetArmyComposition.getUnlimitedComposition(), true);
  m_infiniteRecruit->getTerminateEvent().subscribe(&m_recruitTroopsEndedEventHandler, NULL);
  m_infiniteRecruit->getUnitRecruitedEvent().subscribe(&m_unitRecruitedEventHandler, NULL);
  m_infiniteRecruit->execute();
}

void RecruitArmyTask::onUnitRecruited(void*, const layer2::Recruit* recruit, BWAPI::Unit* unit, StaticLocation* location)
{
  m_layer3Script.onUnitRecruited(unit, location);
}