#pragma once
#include "Layer3Task.h"
#include "../../Interface/ArmyComposition.h"

//
// Input: units composition
//

class RecruitArmyTask : public Layer3Task
{
public:
  RecruitArmyTask(Layer3Script& layer3Script)
    : Layer3Task(layer3Script)
    , m_unitRecruitedEventHandler(*this)
    , m_recruitTroopsEndedEventHandler(*this)
    , m_infiniteRecruit(*this)
  {
  }

  void run();

  virtual void runV()
  {
    run();
  }

  void setTargetArmyComposition(const ArmyComposition& targetArmyComposition)
  {
    m_targetArmyComposition = targetArmyComposition;
  }

  void onRecruitTroopsEnded(void* data);
  void onUnitRecruited(void* data, const layer2::Recruit* recruit, BWAPI::Unit* unit, StaticLocation* location);

  /////////
  // GUI //
  /////////
  const ArmyComposition& getTargetArmyComposition() const
  {
    return m_targetArmyComposition;
  }

protected:
  EVENT_HANDLER3(RecruitArmyTask, onUnitRecruited, const layer2::Recruit*, BWAPI::Unit*, PrimitiveLocation*) m_unitRecruitedEventHandler;
  EVENT_HANDLER(RecruitArmyTask, onRecruitTroopsEnded) m_recruitTroopsEndedEventHandler;

  ProcessContainer<Recruit> m_infiniteRecruit;
  std::map<BWAPI::UnitType, ProcessContainerList<Recruit>> m_finiteRecruits;

  ArmyComposition m_targetArmyComposition;
};
