#pragma once
#include "../../../../PerceptualState/Techs/Tech.h"
#include "../Layer3ScriptTypes.h"

class L3Tech : public virtual Tech
{
public:
  virtual Layer3ScriptTypes::TacticalAction* instantiateAction(unsigned int priority) = 0;
};

class L3UnitTypeTech : public L3Tech, public virtual UnitTypeTech
{
public:
  L3UnitTypeTech(BWAPI::UnitType unitType)
    : UnitTypeTech(unitType)
  {}
  virtual Layer3ScriptTypes::TacticalAction* instantiateAction(unsigned int priority);
};

class L3TechTypeTech : public L3Tech, public virtual TechTypeTech
{
public:
  L3TechTypeTech(BWAPI::TechType techType)
    : TechTypeTech(techType)
  {}
  virtual Layer3ScriptTypes::TacticalAction* instantiateAction(unsigned int priority);
};

class L3UpgradeTypeTech : public L3Tech, public virtual UpgradeTypeTech
{
public:
  L3UpgradeTypeTech(BWAPI::UpgradeType upgradeType)
    : UpgradeTypeTech(upgradeType)
  {}
  L3UpgradeTypeTech(BWAPI::UpgradeType upgradeType, int level)
    : UpgradeTypeTech(upgradeType, level)
  {}
  virtual Layer3ScriptTypes::TacticalAction* instantiateAction(unsigned int priority);
};
