#pragma once
#include "../../../PerceptualState/Techs/Techs.h"
#include "../../../SituationAnalysis/Layer4StrategicRecognition/Layer4StrategicRecognition.h"
#include "../../Layer3Tactical/Script/Layer3Script.h"
#include "../Layer4Strategic.h"
#include "Layer4HeuristicTypes.h"
#include "Tasks/UpdateTargetArmyAndTechsTask.h"

class Layer4Heuristic : public Layer4Strategic<Layer4StrategicRecognition<Layer3TacticalRecognition<Layer2Cueing<Layer1GameState>>>, Layer3Script>,
                        public Layer4HeuristicTypes
{
public:
  Layer4Heuristic(Layer4StrategicRecognition<Layer3TacticalRecognition<Layer2Cueing<Layer1GameState>>>& layer4StrategicRecognition, Layer3Script& layer3Script)
    : Layer4Strategic(layer4StrategicRecognition, layer3Script)
    , m_updateArmyAndTechs(*this)
  {
  }
  void onStart();
  void onFrame();
  void onEnd() {}
  void onSendText(std::string text) {}

  Layer3Script& getLayer3() const { return m_layer3Tactical; }

protected:
  // Periodic tasks
  UpdateTargetArmyAndTechsTask m_updateArmyAndTechs;
};
