#pragma once
#include "UnitDynamicLocation.h"
#include "../Static/Arbitrary/CircularLocation.h"

class CircularUnitDynamicLocation : public UnitDynamicLocation
{
public:
  CircularUnitDynamicLocation(BWAPI::Unit* unit, int radius)
    : UnitDynamicLocation(unit)
    , m_radius(radius)
  {
  }

  CircularUnitDynamicLocation(BWAPI::Unit* unit)
    : UnitDynamicLocation(unit)
    , m_radius(DANGER_DISTANCE)
  {
  }

  CircularLocation getCircularLocation() const
  {
    return CircularLocation(m_unit->getPosition(), m_radius);
  }

  virtual bool isInLocation(BWAPI::Position position) const
  {
    return CircularLocation(m_unit->getPosition(), m_radius).isInLocation(position);
  }

protected:
  virtual void output(std::ostream& out) const
  {
    out << "DynamicCircle(" << *m_unit << ", " << m_radius << ")";
  }

  const int m_radius;
};