#pragma once
#include "DynamicLocation.h"
#include "../../../PersistentUnitGroup.h"

class GroupDynamicLocation : public DynamicLocation
{
public:
  GroupDynamicLocation(const PersistentUnitGroup* group)
    : m_group(group, *this)
  {
  }

  virtual BWAPI::Position getCurrentCenter() const
  {
    return m_group->getCenter();
  }

  const PersistentUnitGroup* getGroup() const
  {
    return m_group;
  }

protected:
  AutoPtr<const PersistentUnitGroup> m_group;
};