#pragma once
#include "GroupDynamicLocation.h"
#include "../Static/Arbitrary/RectangularLocation.h"

class RectangularGroupDynamicLocation : public GroupDynamicLocation
{
public:
  RectangularGroupDynamicLocation(const PersistentUnitGroup* group, int halfAdditionalLengthX, int halfAdditionalLengthY)
    : GroupDynamicLocation(group)
    , m_halfAdditionalLengthX(halfAdditionalLengthX)
    , m_halfAdditionalLengthY(halfAdditionalLengthY)
  {
  }

  RectangularGroupDynamicLocation(const PersistentUnitGroup* group)
    : GroupDynamicLocation(group)
    , m_halfAdditionalLengthX(DANGER_DISTANCE)
    , m_halfAdditionalLengthY(DANGER_DISTANCE)
  {
  }

  virtual bool isInLocation(BWAPI::Position position) const
  {
    if (m_group->size() == 0)
      return false;
    else
      return RectangularLocation::getBoundingBox<PersistentUnitGroup>(m_group).expand(DANGER_DISTANCE, DANGER_DISTANCE).isInLocation(position);
  }

  RectangularLocation getRectangularLocation() const
  {
    return RectangularLocation::getBoundingBox<PersistentUnitGroup>(m_group);
  }

  RectangularLocation getExpandedRectangularLocation() const
  {
    return RectangularLocation::getBoundingBox<PersistentUnitGroup>(m_group).expand(DANGER_DISTANCE, DANGER_DISTANCE);
  }
protected:
  virtual void output(std::ostream& out) const
  {
    out << "DynamicRectangle(" << m_group->getName() << ", " << m_halfAdditionalLengthX << ", " << m_halfAdditionalLengthY << ")";
  }

  const int m_halfAdditionalLengthX;
  const int m_halfAdditionalLengthY;
};