#pragma once
#include "DynamicLocation.h"
#include <BWAPI.h>

class UnitDynamicLocation : public DynamicLocation
{
public:
  UnitDynamicLocation(BWAPI::Unit* unit)
    : m_unit(unit)
  {
  }

  virtual BWAPI::Position getCurrentCenter() const
  {
    return m_unit->getPosition();
  }

  bool isInLocation(BWAPI::Position position) const
  {
    return (m_unit->getPosition()==position);
  }

protected:
  virtual void output(std::ostream& out) const
  {
    out << "unit location " << m_unit->getPosition();
  }

  BWAPI::Unit* const m_unit;
};