#pragma once
#include "../StaticLocation.h"

class CircularLocation : public Location
{
public:
  CircularLocation(BWAPI::Position center, int radius)
    : Location()
    , m_center(center)
    , m_radius(radius)
  {
  }

  virtual bool isInLocation(BWAPI::Position position) const
  {
    const double distance = m_center.getDistance(position);
    return (distance <= static_cast<double>(m_radius));
  }

  virtual BWAPI::Position getCurrentCenter() const
  {
    return m_center;
  }

  int getRadius() const
  {
    return m_radius;
  }
protected:
  virtual void output(std::ostream& out) const
  {
    out << "Circle(" << m_center << ", " << m_radius << ")";
  }

  const BWAPI::Position m_center;
  const int m_radius;
};