#pragma once
#include "../StaticLocation.h"

// Watch out, there are apparently 3 types of coordinates:
// - BWAPI::Position: (x,y) in pixels
// - Small tiles: unit pathfinding?
// - Big tiles: buildings?

class CoordinatesLocation : public Location
{
public:
  CoordinatesLocation(BWAPI::Position coordinates)
    : Location()
    , m_coordinates(coordinates)
  {
    assert(m_coordinates.isValid());
  }

  virtual BWAPI::Position getCurrentCenter() const
  {
    return m_coordinates;
  }

  bool isInLocation(BWAPI::Position position) const
  {
    return m_coordinates == position;
  }
protected:
  virtual void output(std::ostream& out) const
  {
    out << "Coordinates(" << m_coordinates << ")";
  }

  const BWAPI::Position m_coordinates;
};