#include "stdafx.h"
#include "Region.h"
#include "Chokepoint.h"
#include "Map.h"

void Region::addChokepoint(Chokepoint* chokepoint)
{
  std::pair<Region*, Region*> regions = chokepoint->getRegions();
  Region* otherRegion = regions.first == this ? regions.second : regions.first;
  assert(otherRegion != this);
  m_chokepoints.insert(std::make_pair(chokepoint, otherRegion));
  m_adjacentRegions.insert(std::make_pair(otherRegion, chokepoint));
}

Map* Region::getParent()
{
  return dynamic_cast<Map*>(m_parent);
}

const Map* Region::getParent() const
{
  return dynamic_cast<const Map*>(m_parent);
}