#pragma once
#include "PrimitiveLocation.h"

class Map;
class Region;

class RegionLocation : public virtual PrimitiveLocation
{
public:
  template <class LocationTypes>
  RegionLocation(LocationTypes*, Region* parent)
    : PrimitiveLocation(parent)
    , StaticLocation(parent)
  {
  }

  virtual BWAPI::Position getCurrentCenter() const;

  virtual bool isInLocation(BWAPI::Position position) const;

  Region* getParent();
  const Region* getParent() const;

protected:
  friend class Map;

  virtual void output(std::ostream& out) const
  {
    out << "Region location " << getCurrentCenter();
  }
};
