#include "stdafx.h"
#include "StaticLocation.h"
#include "PrimitiveLocation.h"
#include "CompositeLocation.h"

size_t StaticLocation::s_id = 0;

bool StaticLocation::isIn(const CompositeLocation* compositeLocation) const
{
  return this == compositeLocation ||
         (m_parent != NULL && m_parent->isIn(compositeLocation));
}

//std::pair<StaticLocation::own_building_iterator, StaticLocation::own_building_iterator> StaticLocation::getOwnUnits(BWAPI::UnitType unitType)
//{
//  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
//  if (thisPrimitiveLocation != NULL) {
//    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
//    std::pair<PrimitiveLocationBase::own_building_iterator, PrimitiveLocationBase::own_building_iterator> iterators = thisPrimitiveLocation->getOwnUnits(unitType);
//    return std::make_pair(own_building_iterator(iterators.first), own_building_iterator(iterators.second)); 
//  }
//  else {
//    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
//    assert(thisCompositeLocation != NULL);
//    std::pair<CompositeLocationBase::own_building_iterator, CompositeLocationBase::own_building_iterator> iterators = thisCompositeLocation->getOwnUnits(unitType);
//    return std::make_pair(own_building_iterator(iterators.first), own_building_iterator(iterators.second));
//  }
//}
//
//StaticLocation::own_building_iterator StaticLocation::ownBuildingsBegin()
//{
//  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
//  if (thisPrimitiveLocation != NULL) {
//    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
//    return own_building_iterator(thisPrimitiveLocation->ownBuildingsBegin()); 
//  }
//  else {
//    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
//    assert(thisCompositeLocation != NULL);
//    return own_building_iterator(thisCompositeLocation->ownBuildingsBegin()); 
//  }
//}
//
//StaticLocation::own_building_iterator StaticLocation::ownBuildingsEnd()
//{
//  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
//  if (thisPrimitiveLocation != NULL) {
//    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
//    return own_building_iterator(thisPrimitiveLocation->ownBuildingsEnd()); 
//  }
//  else {
//    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
//    assert(thisCompositeLocation != NULL);
//    return own_building_iterator(thisCompositeLocation->ownBuildingsEnd()); 
//  }
//}

std::pair<StaticLocation::own_unit_const_iterator, StaticLocation::own_unit_const_iterator>
  StaticLocation::getOwnUnits() const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::own_unit_const_iterator, PrimitiveLocationBase::own_unit_const_iterator> iterators = thisPrimitiveLocation->getOwnUnits();
    return std::make_pair(own_unit_const_iterator(iterators.first), own_unit_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::own_unit_const_iterator, CompositeLocationBase::own_unit_const_iterator> iterators = thisCompositeLocation->getOwnUnits();
    return std::make_pair(own_unit_const_iterator(iterators.first), own_unit_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::own_unit_type_const_iterator, StaticLocation::own_unit_type_const_iterator> 
  StaticLocation::getOwnUnits(BWAPI::UnitType unitType) const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::own_unit_type_const_iterator, PrimitiveLocationBase::own_unit_type_const_iterator> iterators = thisPrimitiveLocation->getOwnUnits(unitType);
    return std::make_pair(own_unit_type_const_iterator(iterators.first), own_unit_type_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::own_unit_type_const_iterator, CompositeLocationBase::own_unit_type_const_iterator> iterators = thisCompositeLocation->getOwnUnits(unitType);
    return std::make_pair(own_unit_type_const_iterator(iterators.first), own_unit_type_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::own_building_const_iterator, StaticLocation::own_building_const_iterator>
  StaticLocation::getOwnBuildings() const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::own_building_const_iterator, PrimitiveLocationBase::own_building_const_iterator> iterators = thisPrimitiveLocation->getOwnBuildings();
    return std::make_pair(own_building_const_iterator(iterators.first), own_building_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::own_building_const_iterator, CompositeLocationBase::own_building_const_iterator> iterators = thisCompositeLocation->getOwnBuildings();
    return std::make_pair(own_building_const_iterator(iterators.first), own_building_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::enemy_unit_iterator, StaticLocation::enemy_unit_iterator> 
  StaticLocation::getEnemyUnits()
{
  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::enemy_unit_iterator, PrimitiveLocationBase::enemy_unit_iterator> iterators = thisPrimitiveLocation->getEnemyUnits();
    return std::make_pair(enemy_unit_iterator(iterators.first), enemy_unit_iterator(iterators.second)); 
  }
  else {
    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::enemy_unit_iterator, CompositeLocationBase::enemy_unit_iterator> iterators = thisCompositeLocation->getEnemyUnits();
    return std::make_pair(enemy_unit_iterator(iterators.first), enemy_unit_iterator(iterators.second));
  }
}

std::pair<StaticLocation::enemy_unit_const_iterator, StaticLocation::enemy_unit_const_iterator> 
  StaticLocation::getEnemyUnits() const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::enemy_unit_const_iterator, PrimitiveLocationBase::enemy_unit_const_iterator> iterators = thisPrimitiveLocation->getEnemyUnits();
    return std::make_pair(enemy_unit_const_iterator(iterators.first), enemy_unit_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::enemy_unit_const_iterator, CompositeLocationBase::enemy_unit_const_iterator> iterators = thisCompositeLocation->getEnemyUnits();
    return std::make_pair(enemy_unit_const_iterator(iterators.first), enemy_unit_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::enemy_unit_type_iterator, StaticLocation::enemy_unit_type_iterator> 
  StaticLocation::getEnemyUnits(BWAPI::UnitType unitType)
{
  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::enemy_unit_type_iterator, PrimitiveLocationBase::enemy_unit_type_iterator> iterators = thisPrimitiveLocation->getEnemyUnits(unitType);
    return std::make_pair(enemy_unit_type_iterator(iterators.first), enemy_unit_type_iterator(iterators.second)); 
  }
  else {
    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::enemy_unit_type_iterator, CompositeLocationBase::enemy_unit_type_iterator> iterators = thisCompositeLocation->getEnemyUnits(unitType);
    return std::make_pair(enemy_unit_type_iterator(iterators.first), enemy_unit_type_iterator(iterators.second));
  }
}

std::pair<StaticLocation::enemy_unit_type_const_iterator, StaticLocation::enemy_unit_type_const_iterator> 
  StaticLocation::getEnemyUnits(BWAPI::UnitType unitType) const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::enemy_unit_type_const_iterator, PrimitiveLocationBase::enemy_unit_type_const_iterator> iterators = thisPrimitiveLocation->getEnemyUnits(unitType);
    return std::make_pair(enemy_unit_type_const_iterator(iterators.first), enemy_unit_type_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::enemy_unit_type_const_iterator, CompositeLocationBase::enemy_unit_type_const_iterator> iterators = thisCompositeLocation->getEnemyUnits(unitType);
    return std::make_pair(enemy_unit_type_const_iterator(iterators.first), enemy_unit_type_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::enemy_building_iterator, StaticLocation::enemy_building_iterator> 
  StaticLocation::getEnemyBuildings()
{
  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::enemy_building_iterator, PrimitiveLocationBase::enemy_building_iterator> iterators = thisPrimitiveLocation->getEnemyBuildings();
    return std::make_pair(enemy_building_iterator(iterators.first), enemy_building_iterator(iterators.second)); 
  }
  else {
    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::enemy_building_iterator, CompositeLocationBase::enemy_building_iterator> iterators = thisCompositeLocation->getEnemyBuildings();
    return std::make_pair(enemy_building_iterator(iterators.first), enemy_building_iterator(iterators.second));
  }
}

std::pair<StaticLocation::enemy_building_const_iterator, StaticLocation::enemy_building_const_iterator> 
  StaticLocation::getEnemyBuildings() const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::enemy_building_const_iterator, PrimitiveLocationBase::enemy_building_const_iterator> iterators = thisPrimitiveLocation->getEnemyBuildings();
    return std::make_pair(enemy_building_const_iterator(iterators.first), enemy_building_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::enemy_building_const_iterator, CompositeLocationBase::enemy_building_const_iterator> iterators = thisCompositeLocation->getEnemyBuildings();
    return std::make_pair(enemy_building_const_iterator(iterators.first), enemy_building_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::neutral_unit_const_iterator, StaticLocation::neutral_unit_const_iterator> 
  StaticLocation::getNeutralUnits() const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::neutral_unit_const_iterator, PrimitiveLocationBase::neutral_unit_const_iterator> iterators = thisPrimitiveLocation->getNeutralUnits();
    return std::make_pair(neutral_unit_const_iterator(iterators.first), neutral_unit_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::neutral_unit_const_iterator, CompositeLocationBase::neutral_unit_const_iterator> iterators = thisCompositeLocation->getNeutralUnits();
    return std::make_pair(neutral_unit_const_iterator(iterators.first), neutral_unit_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::neutral_unit_iterator, StaticLocation::neutral_unit_iterator> 
  StaticLocation::getNeutralUnits()
{
  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::neutral_unit_iterator, PrimitiveLocationBase::neutral_unit_iterator> iterators = thisPrimitiveLocation->getNeutralUnits();
    return std::make_pair(neutral_unit_iterator(iterators.first), neutral_unit_iterator(iterators.second)); 
  }
  else {
    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::neutral_unit_iterator, CompositeLocationBase::neutral_unit_iterator> iterators = thisCompositeLocation->getNeutralUnits();
    return std::make_pair(neutral_unit_iterator(iterators.first), neutral_unit_iterator(iterators.second));
  }
}

std::pair<StaticLocation::neutral_unit_type_const_iterator, StaticLocation::neutral_unit_type_const_iterator> 
  StaticLocation::getNeutralUnits(BWAPI::UnitType unitType) const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::neutral_unit_type_const_iterator, PrimitiveLocationBase::neutral_unit_type_const_iterator> iterators = thisPrimitiveLocation->getNeutralUnits(unitType);
    return std::make_pair(neutral_unit_type_const_iterator(iterators.first), neutral_unit_type_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::neutral_unit_type_const_iterator, CompositeLocationBase::neutral_unit_type_const_iterator> iterators = thisCompositeLocation->getNeutralUnits(unitType);
    return std::make_pair(neutral_unit_type_const_iterator(iterators.first), neutral_unit_type_const_iterator(iterators.second));
  }
}

std::pair<StaticLocation::neutral_unit_type_iterator, StaticLocation::neutral_unit_type_iterator> 
  StaticLocation::getNeutralUnits(BWAPI::UnitType unitType)
{
  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::neutral_unit_type_iterator, PrimitiveLocationBase::neutral_unit_type_iterator> iterators = thisPrimitiveLocation->getNeutralUnits(unitType);
    return std::make_pair(neutral_unit_type_iterator(iterators.first), neutral_unit_type_iterator(iterators.second)); 
  }
  else {
    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::neutral_unit_type_iterator, CompositeLocationBase::neutral_unit_type_iterator> iterators = thisCompositeLocation->getNeutralUnits(unitType);
    return std::make_pair(neutral_unit_type_iterator(iterators.first), neutral_unit_type_iterator(iterators.second));
  }
}

std::pair<StaticLocation::neutral_building_iterator, StaticLocation::neutral_building_iterator> 
  StaticLocation::getNeutralBuildings()
{
  PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::neutral_building_iterator, PrimitiveLocationBase::neutral_building_iterator> iterators = thisPrimitiveLocation->getNeutralBuildings();
    return std::make_pair(neutral_building_iterator(iterators.first), neutral_building_iterator(iterators.second)); 
  }
  else {
    CompositeLocation* thisCompositeLocation = dynamic_cast<CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::neutral_building_iterator, CompositeLocationBase::neutral_building_iterator> iterators = thisCompositeLocation->getNeutralBuildings();
    return std::make_pair(neutral_building_iterator(iterators.first), neutral_building_iterator(iterators.second));
  }
}

std::pair<StaticLocation::neutral_building_const_iterator, StaticLocation::neutral_building_const_iterator> 
  StaticLocation::getNeutralBuildings() const
{
  const PrimitiveLocation* thisPrimitiveLocation = dynamic_cast<const PrimitiveLocation*>(this);
  if (thisPrimitiveLocation != NULL) {
    assert(dynamic_cast<const CompositeLocation*>(this) == NULL);
    std::pair<PrimitiveLocationBase::neutral_building_const_iterator, PrimitiveLocationBase::neutral_building_const_iterator> iterators = thisPrimitiveLocation->getNeutralBuildings();
    return std::make_pair(neutral_building_const_iterator(iterators.first), neutral_building_const_iterator(iterators.second)); 
  }
  else {
    const CompositeLocation* thisCompositeLocation = dynamic_cast<const CompositeLocation*>(this);
    assert(thisCompositeLocation != NULL);
    std::pair<CompositeLocationBase::neutral_building_const_iterator, CompositeLocationBase::neutral_building_const_iterator> iterators = thisCompositeLocation->getNeutralBuildings();
    return std::make_pair(neutral_building_const_iterator(iterators.first), neutral_building_const_iterator(iterators.second));
  }
}