#pragma once
#include "../../Scheduler/Scheduler.h"
#include "../InfluenceMap/InfluenceMap.h"

template <class InfluenceType>
class UpdateInfluenceMapTask : public Scheduler::InternalSchedulerTask
{
public:
  UpdateInfluenceMapTask(const Component& owner, InfluenceMap<InfluenceType>& influenceMap)
    : Scheduler::InternalSchedulerTask(owner)
    , m_influenceMap(influenceMap)
  {}
  void run()
  {
    m_influenceMap.update();
  }
protected:
  virtual void runV()
  {
    run();
  }
  InfluenceMap<InfluenceType>& m_influenceMap;
};
