#pragma once
#include "../../Scheduler/Scheduler.h"
#include "../Locations/Static/StaticLocation.h"

class UpdateUnitsTask : public Scheduler::InternalSchedulerTask
{
public:
  UpdateUnitsTask(const Component& owner, StaticLocation* location)
    : Scheduler::InternalSchedulerTask(owner)
    , m_location(location)
  {}
  void run()
  {
    m_location->updateOwnUnits();
    m_location->updateEnemyUnits();
    m_location->updateNeutralUnits();
  }
protected:
  virtual void runV()
  {
    run();
  }
  StaticLocation* const m_location;
};
