#include "stdafx.h"
#include "Techs.h"
#include "../../SparAIContainer.h"

Techs::TechEvents Techs::TechEvents::s_techEvents;
const Map* Techs::s_map;

Techs::OnTechAcquired Techs::s_techAcquiredEvent;
Techs::OnTechLost Techs::s_techLostEvent;

stdext::hash_map<BWAPI::UnitType, UnitTypeTech*> Techs::UnitTypeTechs;
stdext::hash_map<BWAPI::TechType, TechTypeTech*> Techs::TechTypeTechs;
stdext::hash_map<std::pair<BWAPI::UpgradeType, int>, UpgradeTypeTech*, Techs::UpgradeHashCompare> Techs::UpgradeTypeTechs;

UnitTypeTech* Techs::NexusTech;
UnitTypeTech* Techs::PylonTech;
UnitTypeTech* Techs::AssimilatorTech;
UnitTypeTech* Techs::GatewayTech;
UnitTypeTech* Techs::ShieldBatteryTech;
UnitTypeTech* Techs::ForgeTech;
UnitTypeTech* Techs::PhotonCannonTech;
UnitTypeTech* Techs::CyberneticsCoreTech;
UnitTypeTech* Techs::RoboticsFacilityTech;
UnitTypeTech* Techs::RoboticsSupportBayTech;
UnitTypeTech* Techs::ObservatoryTech;
UnitTypeTech* Techs::StargateTech;
UnitTypeTech* Techs::FleetBeaconTech;
UnitTypeTech* Techs::ArbiterTribunalTech;
UnitTypeTech* Techs::CitadelOfAdunTech;
UnitTypeTech* Techs::TemplarArchivesTech;

UnitTypeTech* Techs::ProbeTech;
UnitTypeTech* Techs::ZealotTech;
UnitTypeTech* Techs::DragoonTech;
UnitTypeTech* Techs::HighTemplarTech;
UnitTypeTech* Techs::DarkTemplarTech;
UnitTypeTech* Techs::ArchonTech;
UnitTypeTech* Techs::DarkArchonTech;
UnitTypeTech* Techs::ReaverTech;
UnitTypeTech* Techs::ShuttleTech;
UnitTypeTech* Techs::ObserverTech;
UnitTypeTech* Techs::CorsairTech;
UnitTypeTech* Techs::ScoutTech;
UnitTypeTech* Techs::CarrierTech;
UnitTypeTech* Techs::ArbiterTech;

TechTypeTech* Techs::DisruptionWebTech;
TechTypeTech* Techs::FeedbackTech;
TechTypeTech* Techs::HallucinationTech;
TechTypeTech* Techs::MaelstromTech;
TechTypeTech* Techs::MindControlTech;
TechTypeTech* Techs::PsionicStormTech;
TechTypeTech* Techs::RecallTech;
TechTypeTech* Techs::StasisFieldTech;

UpgradeTypeTech* Techs::GroundWeapons[3];
UpgradeTypeTech* Techs::GroundArmor[3];
UpgradeTypeTech* Techs::AirWeapons[3];
UpgradeTypeTech* Techs::AirArmor[3];
UpgradeTypeTech* Techs::PlasmaShields[3];
UpgradeTypeTech* Techs::SingularityCharge;
UpgradeTypeTech* Techs::LegEnhancements;
UpgradeTypeTech* Techs::GraviticDrive;
UpgradeTypeTech* Techs::CarrierCapacity;
UpgradeTypeTech* Techs::ReaverCapacity;
UpgradeTypeTech* Techs::ScarabDamage;
UpgradeTypeTech* Techs::GraviticBoosters;
UpgradeTypeTech* Techs::SensorArray;
UpgradeTypeTech* Techs::ApialSensors;
UpgradeTypeTech* Techs::GraviticThrusters;
UpgradeTypeTech* Techs::ArgusJewel;
UpgradeTypeTech* Techs::ArgusTalisman;
UpgradeTypeTech* Techs::KhaydarinAmulet;
UpgradeTypeTech* Techs::KhaydarinCore;

void Techs::onEnd()
{
  TechEvents::onEnd(s_map);

  std::pair<tech_const_iterator, tech_const_iterator> techs = getAllTechs();
  for (; techs.first != techs.second; ++techs.first)
    delete *techs.first;
}

void Techs::TechEvents::onOwnUnitCompleted(void* data, BWAPI::Unit* unit)
{
  if (unit->getPlayer() == BWAPI::Broodwar->self())
  {
    BWAPI::UnitType unitType = unit->getType();
    if (unitType.isBuilding())
    {
      UnitTypeTech* tech = Techs::getUnitTypeTech(unitType);
      if (tech != NULL)
      {
        tech->onUnitCompleted();
      }
    }
  }
}

void Techs::TechEvents::onOwnUnitRemoved(void* data, OwnUnit* ownUnit)
{
  BWAPI::UnitType unitType = ownUnit->getUnit()->getType();
  if (unitType.isBuilding())
  {
    UnitTypeTech* tech = Techs::getUnitTypeTech(unitType);
    if (tech != NULL)
    {
      tech->onUnitRemoved(Techs::s_map->getNbCompletedOwnUnits(unitType));
    }
  }
}
