#pragma once
#include "UnitLocationData.h"

/**
 * @brief Enemy units information stored in locations.
 */
class EnemyUnit : public ForeignUnit
{
public:
  EnemyUnit(BWAPI::Unit* unit, PrimitiveLocation* location)
    : ForeignUnit(unit, location)
  {
    assert(unit->getPlayer()->isEnemy(BWAPI::Broodwar->self()));
  }

  friend std::ostream& operator<<(std::ostream& out, const EnemyUnit& enemyUnit)
  {
    if (enemyUnit.isAccessible())
    {
      BWAPI::Unit* unit = enemyUnit.getUnit();
      out << "Enemy unit (0x" << std::nouppercase << std::hex << unit << std::dec << ") " << unit->getType().getName() << ", hit points " << unit->getHitPoints();
    }
    else
    {
      const EnemyUnit::SavedState& state = enemyUnit.getLastKnownState();
      out << "Enemy saved unit (0x" << std::nouppercase << std::hex << enemyUnit.m_unit << std::dec << ") " << state.getType().getName() << ", hit points " << state.getHitPoints();
    }
    return out;
  }
};
