#pragma once
#include "UnitLocationData.h"

/**
 * @brief Neutral units information stored in locations.
 */
class NeutralUnit : public ForeignUnit
{
public:
  NeutralUnit(BWAPI::Unit* unit, PrimitiveLocation* location)
    : ForeignUnit(unit, location)
  {
    assert(unit->getPlayer() == BWAPI::Broodwar->neutral());
  }

  friend std::ostream& operator<<(std::ostream& out, const NeutralUnit& neutralUnit)
  {
    if (neutralUnit.isAccessible())
    {
      BWAPI::Unit* unit = neutralUnit.getUnit();
      out << "Neutral unit (0x" << std::nouppercase << std::hex << unit << std::dec << ") " << unit->getType().getName() << ", hit points " << unit->getHitPoints();
    }
    else
    {
      const NeutralUnit::SavedState& state = neutralUnit.getLastKnownState();
      out << "Neutral saved unit (0x" << std::nouppercase << std::hex << neutralUnit.m_unit << std::dec << ") " << state.getType().getName() << ", hit points " << state.getHitPoints();
    }
    return out;
  }
};
