#include "stdafx.h"
#include "PersistentUnitGroup.h"

const PersistentUnitGroup PersistentUnitGroup::EmptyGroup;

PersistentUnitGroup::PersistentUnitGroup()
  : m_name("Empty-group")
  , m_unitDestroyEventHandler(*this)
{
  assert(this == &EmptyGroup);
  markAsStatic();
}

PersistentUnitGroup::~PersistentUnitGroup()
{
  m_groupDestroyedEvent.raise();

  UnitWrapperSet::iterator it = m_group.begin();
  while (it != m_group.end())
  {
    UnitWrapperSet::iterator next = it;
    ++next;
    remove(it);
    it = next;
  }
}

std::ostream& operator<<(std::ostream& out, const PersistentUnitGroup& group)
{
  out << static_cast<const GroupBase<PersistentUnitGroup>&>(group);
  //out << group.m_name << ": ";
  //std::transform(
  //  group.begin(),
  //  group.end(),
  //  std::ostream_iterator<BWAPI::Unit>(out, "; "),
  //  dereference<Unit>());
  return out;
}