#ifndef WINDOWS_TIMER_H
#define WINDOWS_TIMER_H

#include "ITimer.h"
#include <windows.h>

/**
 * @brief Timer for the windows plateform.
 */

class WindowsTimer : public ITimer
{
	LARGE_INTEGER m_frequency;
public:
	WindowsTimer()
	{
		QueryPerformanceFrequency(&m_frequency);
	}

	const value_type currentTime()
	{
		LARGE_INTEGER tick;
		QueryPerformanceCounter(&tick);
		return tick.QuadPart;
	}

	const value_type timeFrequency()
	{
		return m_frequency.QuadPart;
	}

};

#endif