#pragma once
#include <BWAPI.h>

// Separate between OwnUnitData/NeutralUnitData/EnemyUnitData?

class PrimitiveLocation;

class UnitData
{
public:
  UnitData(BWAPI::Unit* unit)
    : m_unit(unit)
    , m_location(NULL)
    , m_data(NULL)
  {
    m_unit->setClientInfo(this);
  }

  virtual ~UnitData()
  {
    m_unit->setClientInfo(NULL);
  }

protected:
  friend class UnitManager;
  // TODO: delete
  friend class PrimitiveLocation;

  DECLARE_EVENT(OnIndividualUnitDestroy);
  EVENT(OnIndividualUnitDestroy) m_individualUnitDestroyEvent;

  DECLARE_EVENT(OnIndividualUnitEvade);
  EVENT(OnIndividualUnitEvade) m_individualUnitEvadeEvent;
  
  DECLARE_EVENT(OnIndividualUnitMorph);
  EVENT(OnIndividualUnitMorph) m_individualUnitMorphEvent;

  DECLARE_EVENT(OnIndividualUnitRenegade);
  EVENT(OnIndividualUnitRenegade) m_individualUnitRenegadeEvent;

  BWAPI::Unit* const m_unit;

  PrimitiveLocation* m_location;
  void* m_data; // TODO: this is a ghetto fix to point on the UnitLocationData*

  std::list<UnitData*>::const_iterator m_posInManager;
};