#include "stdafx.h"
#include "UnitManager.h"

UnitManager::~UnitManager()
{
  for (std::list<UnitData*>::const_iterator it = m_unitDataList.begin(); it != m_unitDataList.end(); ++it)
  {
    delete *it;
  }
}

UnitData& UnitManager::getUnitData(BWAPI::Unit* unit)
{
  UnitData* unitData = reinterpret_cast<UnitData*>(unit->getClientInfo());
  if (unitData == NULL)
  {
    unitData = instantiateUnitData(unit);
    unitData->m_posInManager = m_unitDataList.insert(m_unitDataList.end(), unitData);
    //unit->setClientInfo(unitData);
    assert(unit->getClientInfo() == unitData);
  }
  return *unitData;
}

void UnitManager::onUnitDestroy(BWAPI::Unit* unit)
{
  //if (unit->getPlayer() == BWAPI::Broodwar->self())
  //{
    UnitData* unitData = reinterpret_cast<UnitData*>(unit->getClientInfo());
    if (unitData != NULL)
    {
      unitData->m_individualUnitDestroyEvent.raise();
      m_unitDataList.erase(unitData->m_posInManager);
      // This is supposed to trigger the deletion of behaviors associated to these units
      delete unitData;
      //unit->setClientInfo(NULL);
      assert(unit->getClientInfo() == NULL);
    }
  //}
}
