#include "stdafx.h"
#include "Component.h"

#ifdef _DEBUG_COMPONENT
#include "../SparAIContainer.h"
#include "../Scheduler/Scheduler.h"

bool Component::ownsAtLeastOneActiveTask() const
{
  struct IsOwner
  {
    IsOwner(const Component* owner)
      : m_owner(owner)
      , m_result(false)
    {}
    SafeMultisetBase::ConstFunctionReturn operator()(const Scheduler::InternalSchedulerTask* task)
    {
      m_result = (&task->m_owner == m_owner);
      return SafeMultisetBase::ConstFunctionReturn(m_result);
    }
    bool getResult() const
    {
      return m_result;
    }
  private:
    const Component* m_owner;
    bool m_result;
  };

  return Spar->getScheduler().for_each_task(IsOwner(this)).getResult();
}

#endif