#include "stdafx.h"
#include "Process.h"
#include "../SparAIContainer.h" // for Spar->addZombieComponent()

const Process::Mode Process::WaitingToExecute;

const Process::ExecutionMode Process::Executing;

const Process::TerminationMode Process::Success;
     
const Process::TerminationMode Process::ExternalEvent;

//Process::ProcessZombification Process::ProcessZombification::s_processZombification;
//
//void Process::ProcessZombification::onTerminate(void* data)
//{
//  const Process* process = reinterpret_cast<const Process*>(data);
//
//  Spar->addZombieComponent(process);
//}

void Process::terminate(const Process::TerminationMode& mode)
{
  if (!isTerminated())
  {
    assert(isExecuting());

    m_currentMode = &mode;

    terminateImpl();

    m_terminateEvent.raise();

    // Terminate all child processes here
    for_each_child_process(TerminateProcess());

    if (m_zombifyOnTerminate)
      Spar->addZombieComponent(this);

//#ifdef _DEBUG_COMPONENT
//    // Can't do that here since some stuff is unregistered in the destructor only (for example ProcessContainer)
//    verifyPendingSubscriptions("ERROR Process::terminate(): Make sure to unsubscribe EventHandler \"%s\" from event \"%s\" when its owner process terminates.");
//
//    verifyPendingTasks("ERROR Process::terminate(): Make sure to deactivate task \"%s\" when its owner process terminates.");
//#endif
  }
  else
  {
    SPAR_LOG(LogTypes::GENERAL_ERROR, "WARNING Process::terminate() has been called twice (for process \"%s\")", getObjectDescription(this).c_str());
  }
}