#pragma once
#include <BWAPI.h>
#include <SparAIModule.h>

class Scenarios
{
private:
  static SparAIContainer* instantiateAIModuleScenario1();

  static SparAIContainer* instantiateAIModuleScenario2();

  static SparAIContainer* instantiateAIModuleScenarioReaver();

  static SparAIContainer* instantiateAIModuleScoutScenario();

  static SparAIContainer* instantiateAIModuleObserverScenario();

  static SparAIContainer* instantiateAITestCallbacks();

public:
  static SparAIContainer* instantiateSparAIForScenarios()
  {
    const std::string mapName = BWAPI::Broodwar->mapName();
    if (mapName == "AI Scenario 1")
    {
      return instantiateAIModuleScenario1();
    }
    else if (mapName == "AI Scenario 2")
    {
      return instantiateAIModuleScenario2();
    }
    else if (mapName == "reaver")
    {
      return instantiateAIModuleScenarioReaver();
    }
    else if (mapName == "scout scenario")
    {
      return instantiateAIModuleScoutScenario();
    }
    else if (mapName == "observer")
    {
      return instantiateAIModuleObserverScenario();
    }
    else if (mapName == "TestCallbacks")
    {
      return instantiateAITestCallbacks();
    }
    else
    {
      return NULL;
    }
  }
};
