#pragma once
#include <QtGui/QTreeWidgetItem>

class QTreeWidgetItemKey : public QTreeWidgetItem
{
public:
  QTreeWidgetItemKey(QTreeWidget *view)
    : QTreeWidgetItem(view)
    , m_key(NULL)
  {
  }
  QTreeWidgetItemKey(QTreeWidgetItem *item)
    : QTreeWidgetItem(item)
    , m_key(NULL)
  {
  }
  ~QTreeWidgetItemKey() {}
  const void* getKey() const { return m_key; }
  void setKey(const void* key) { m_key = key; }
private:
  const void* m_key;
};


template <class CustomData>
class QTreeWidgetItemCustom : public QTreeWidgetItemKey
{
public:
  QTreeWidgetItemCustom(QTreeWidget *view)
    : QTreeWidgetItemKey(view)
    , m_data()
  {
  }
  QTreeWidgetItemCustom(QTreeWidgetItem *item)
    : QTreeWidgetItemKey(item)
    , m_data()
  {
  }
  CustomData getCustomData() { return m_data; }
  void setCustomData(CustomData data) { m_data = data; }
private:
  CustomData m_data;
};
