#include "stdafx.h"
#include "Location.h"

LocationWrapper* LocationWrapper::createWrapper(const Location* location)
{
  const CompositeLocation* compositeLocation = dynamic_cast<const CompositeLocation*>(location);
  if (compositeLocation != NULL)
  {
    return new CompositeLocationWrapper(compositeLocation);
  }
  else
  {
    const PrimitiveLocation* primitiveLocation = dynamic_cast<const PrimitiveLocation*>(location);
    return new PrimitiveLocationWrapper(primitiveLocation);
  }
}
