#pragma once
#include <QtGui/QListWidgetItem>
#include <PerceptualState/Techs/Tech.h>

class TechWrapper
{
public:
  TechWrapper(const Tech* tech)
    : m_name(QString::fromStdString(getObjectDescription(tech)))
    , m_isAcquired(tech->isAcquired())
  {}
  void displayIn(QListWidgetItem* item) const
  {
    //item->setKey(m_location);
    item->setText(m_name);
    if (m_isAcquired)
    {
      QFont font = item->font();
      font.setBold(true);
      item->setFont(font);
    }
  };
private:
  QString m_name;
  bool m_isAcquired;
};